/**
  ******************************************************************************
  * @ļ    stm32f10x_tim.c
  * @    MCD Ӧó
  * @汾    V3.1.0
  * @    06/19/2009
  * @    ļ ṩ TIM ̼.
  * @    ANSON/sweet1985 Email:airanson110@126.com
  * @    10/07/2009
  ******************************************************************************
  * @
  *
  * ̼ṩͻΪƲƷдĲοĿʹͻԼʱ䡣
  * ͻʹñ̼ڿƷϲĽⷨ뵼幫˾еκֱӵĺͼ
  * ΣҲеκ𺦶⳥
  *
  * <h2><center>&; Ȩ 2009 ⷨ뵼幫˾</center></h2>
  * 汾ѧϰӢԭгӦӢԭΪ׼
  */ 

/*  ------------------------------------------------------------------*/
#include "stm32f10x_tim.h"
#include "stm32f10x_rcc.h"

/*  --------------------------------------------------------------*/
/* ö --------------------------------------------------------------*/

/* ---------------------- TIM registers bit mask ------------------------ */
#define CR1_CEN_Set                 ((uint16_t)0x0001)
#define CR1_CEN_Reset               ((uint16_t)0x03FE)
#define CR1_UDIS_Set                ((uint16_t)0x0002)
#define CR1_UDIS_Reset              ((uint16_t)0x03FD)
#define CR1_URS_Set                 ((uint16_t)0x0004)
#define CR1_URS_Reset               ((uint16_t)0x03FB)
#define CR1_OPM_Reset               ((uint16_t)0x03F7)
#define CR1_CounterMode_Mask        ((uint16_t)0x038F)
#define CR1_ARPE_Set                ((uint16_t)0x0080)
#define CR1_ARPE_Reset              ((uint16_t)0x037F)
#define CR1_CKD_Mask                ((uint16_t)0x00FF)
#define CR2_CCPC_Set                ((uint16_t)0x0001)
#define CR2_CCPC_Reset              ((uint16_t)0xFFFE)
#define CR2_CCUS_Set                ((uint16_t)0x0004)
#define CR2_CCUS_Reset              ((uint16_t)0xFFFB)
#define CR2_CCDS_Set                ((uint16_t)0x0008)
#define CR2_CCDS_Reset              ((uint16_t)0xFFF7)
#define CR2_MMS_Mask                ((uint16_t)0xFF8F)
#define CR2_TI1S_Set                ((uint16_t)0x0080)
#define CR2_TI1S_Reset              ((uint16_t)0xFF7F)
#define CR2_OIS1_Reset              ((uint16_t)0x7EFF)
#define CR2_OIS1N_Reset             ((uint16_t)0x7DFF)
#define CR2_OIS2_Reset              ((uint16_t)0x7BFF)
#define CR2_OIS2N_Reset             ((uint16_t)0x77FF)
#define CR2_OIS3_Reset              ((uint16_t)0x6FFF)
#define CR2_OIS3N_Reset             ((uint16_t)0x5FFF)
#define CR2_OIS4_Reset              ((uint16_t)0x3FFF)
#define SMCR_SMS_Mask               ((uint16_t)0xFFF8)
#define SMCR_ETR_Mask               ((uint16_t)0x00FF)
#define SMCR_TS_Mask                ((uint16_t)0xFF8F)
#define SMCR_MSM_Reset              ((uint16_t)0xFF7F)
#define SMCR_ECE_Set                ((uint16_t)0x4000)
#define CCMR_CC13S_Mask             ((uint16_t)0xFFFC)
#define CCMR_CC24S_Mask             ((uint16_t)0xFCFF)
#define CCMR_TI13Direct_Set         ((uint16_t)0x0001)
#define CCMR_TI24Direct_Set         ((uint16_t)0x0100)
#define CCMR_OC13FE_Reset           ((uint16_t)0xFFFB)
#define CCMR_OC24FE_Reset           ((uint16_t)0xFBFF)
#define CCMR_OC13PE_Reset           ((uint16_t)0xFFF7)
#define CCMR_OC24PE_Reset           ((uint16_t)0xF7FF)
#define CCMR_OC13M_Mask             ((uint16_t)0xFF8F)
#define CCMR_OC24M_Mask             ((uint16_t)0x8FFF) 
#define CCMR_OC13CE_Reset           ((uint16_t)0xFF7F)
#define CCMR_OC24CE_Reset           ((uint16_t)0x7FFF)
#define CCMR_IC13PSC_Mask           ((uint16_t)0xFFF3)
#define CCMR_IC24PSC_Mask           ((uint16_t)0xF3FF)
#define CCMR_IC13F_Mask             ((uint16_t)0xFF0F)
#define CCMR_IC24F_Mask             ((uint16_t)0x0FFF)
#define CCMR_Offset                 ((uint16_t)0x0018)
#define CCER_CCE_Set                ((uint16_t)0x0001)
#define	CCER_CCNE_Set               ((uint16_t)0x0004)
#define CCER_CC1P_Reset             ((uint16_t)0xFFFD)
#define CCER_CC2P_Reset             ((uint16_t)0xFFDF)
#define CCER_CC3P_Reset             ((uint16_t)0xFDFF)
#define CCER_CC4P_Reset             ((uint16_t)0xDFFF)
#define CCER_CC1NP_Reset            ((uint16_t)0xFFF7)
#define CCER_CC2NP_Reset            ((uint16_t)0xFF7F)
#define CCER_CC3NP_Reset            ((uint16_t)0xF7FF)
#define CCER_CC1E_Set               ((uint16_t)0x0001)
#define CCER_CC1E_Reset             ((uint16_t)0xFFFE)
#define CCER_CC1NE_Reset            ((uint16_t)0xFFFB)
#define CCER_CC2E_Set               ((uint16_t)0x0010)
#define CCER_CC2E_Reset             ((uint16_t)0xFFEF)
#define CCER_CC2NE_Reset            ((uint16_t)0xFFBF)
#define CCER_CC3E_Set               ((uint16_t)0x0100)
#define CCER_CC3E_Reset             ((uint16_t)0xFEFF)
#define CCER_CC3NE_Reset            ((uint16_t)0xFBFF)
#define CCER_CC4E_Set               ((uint16_t)0x1000)
#define CCER_CC4E_Reset             ((uint16_t)0xEFFF)
#define BDTR_MOE_Set                ((uint16_t)0x8000)
#define BDTR_MOE_Reset              ((uint16_t)0x7FFF)

/* ú -------------------------------------------------------------*/
/* ñ -----------------------------------------------------------*/
/* úԭ -------------------------------------------------------*/

static void TI1_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter);
static void TI2_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter);
static void TI3_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter);
static void TI4_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter);

/* ú -----------------------------------------------------------*/

/**
  * @   TIMx ĴΪȱʡֵ.
  * @  TIMx: ˴x18ѡ.
  * @  û
  */
void TIM_DeInit(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx)); 
 
  if (TIMx == TIM1)
  {
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM1, ENABLE);
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM1, DISABLE);  
  }     
  else if (TIMx == TIM2)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM2, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM2, DISABLE);
  }
  else if (TIMx == TIM3)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM3, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM3, DISABLE);
  }
  else if (TIMx == TIM4)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM4, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM4, DISABLE);
  } 
  else if (TIMx == TIM5)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM5, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM5, DISABLE);
  } 
  else if (TIMx == TIM6)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM6, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM6, DISABLE);
  } 
  else if (TIMx == TIM7)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM7, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM7, DISABLE);
  } 
  else
  {
    if (TIMx == TIM8)
    {
      RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM8, ENABLE);
      RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM8, DISABLE);
    }  
  }
}

/**
  * @   TIM_TimeBaseInitStruct ָĲʼ TIMx ʱλ.
  * @  TIMx:  x  1, 2, 3, 4, 5  8 趨 TIM .
  * @  TIM_TimeBaseInitStruct: ָһ TIM ʱϢ TIM_BaseInitTypeDef ṹָ.
  * @  û
  */
void TIM_TimeBaseInit(TIM_TypeDef* TIMx, TIM_TimeBaseInitTypeDef* TIM_TimeBaseInitStruct)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx)); 
  assert_param(IS_TIM_COUNTER_MODE(TIM_TimeBaseInitStruct->TIM_CounterMode));
  assert_param(IS_TIM_CKD_DIV(TIM_TimeBaseInitStruct->TIM_ClockDivision));
  /* ѡģʽ ʱƵ */
  TIMx->CR1 &= CR1_CKD_Mask & CR1_CounterMode_Mask;
  TIMx->CR1 |= (uint32_t)TIM_TimeBaseInitStruct->TIM_ClockDivision |
                TIM_TimeBaseInitStruct->TIM_CounterMode;
  
  /* Զװֵ */
  TIMx->ARR = TIM_TimeBaseInitStruct->TIM_Period ;
 
  /* ԤƵֵ */
  TIMx->PSC = TIM_TimeBaseInitStruct->TIM_Prescaler;
    
  if ((((uint32_t) TIMx) == TIM1_BASE) || (((uint32_t) TIMx) == TIM8_BASE))  
  {
    /* ظֵ */
    TIMx->RCR = TIM_TimeBaseInitStruct->TIM_RepetitionCounter;
  }

  /* һ¼װԤƵֵ */
  TIMx->EGR = TIM_PSCReloadMode_Immediate;          
}

/**
  * @   TIM_OCInitStruct еضʼTIMxͨ1.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCInitStruct: ָһضTIMxϢ TIM_OCInitTypeDef ṹָ.
  * @  û
  */
void TIM_OC1Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct)
{
  uint16_t tmpccmrx = 0, tmpccer = 0, tmpcr2 = 0;
   
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx)); 
  assert_param(IS_TIM_OC_MODE(TIM_OCInitStruct->TIM_OCMode));
  assert_param(IS_TIM_OUTPUT_STATE(TIM_OCInitStruct->TIM_OutputState));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCInitStruct->TIM_OCPolarity));   
  /* ʧͨ 1: λ CC1E λ */
  TIMx->CCER &= CCER_CC1E_Reset;
  
  /* õ TIMx CCER(/Ƚʹ) Ĵֵ */
  tmpccer = TIMx->CCER;
  /* õ TIMx CR2(ƼĴ2) Ĵֵ */
  tmpcr2 =  TIMx->CR2;
  
  /* õ TIMx CCMR1(/Ƚģʽ) Ĵֵ */
  tmpccmrx = TIMx->CCMR1;
    
  /* λȽģʽλ */
  tmpccmrx &= CCMR_OC13M_Mask;
  
  /* ѡȽģʽ */
  tmpccmrx |= TIM_OCInitStruct->TIM_OCMode;
  
  /* λԵȼ */
  tmpccer &= CCER_CC1P_Reset;
  /* Ƚϼ */
  tmpccer |= TIM_OCInitStruct->TIM_OCPolarity;
  
  /* ״̬ */
  tmpccer |= TIM_OCInitStruct->TIM_OutputState;
  
  /* òȽϼĴֵ */
  TIMx->CCR1 = TIM_OCInitStruct->TIM_Pulse;
  
  if(((uint32_t) TIMx == TIM1_BASE) || ((uint32_t) TIMx == TIM8_BASE))
  {
    assert_param(IS_TIM_OUTPUTN_STATE(TIM_OCInitStruct->TIM_OutputNState));
    assert_param(IS_TIM_OCN_POLARITY(TIM_OCInitStruct->TIM_OCNPolarity));
    assert_param(IS_TIM_OCNIDLE_STATE(TIM_OCInitStruct->TIM_OCNIdleState));
    assert_param(IS_TIM_OCIDLE_STATE(TIM_OCInitStruct->TIM_OCIdleState));
    
    /* λ N Եȼ */
    tmpccer &= CCER_CC1NP_Reset;
    /*  N  */
    tmpccer |= TIM_OCInitStruct->TIM_OCNPolarity;
    /* λ N ״̬ */
    tmpccer &= CCER_CC1NE_Reset;
    
    /*  N ״̬ */
    tmpccer |= TIM_OCInitStruct->TIM_OutputNState;
    /* λȽϣȽ N ״̬ */
    tmpcr2 &= CR2_OIS1_Reset;
    tmpcr2 &= CR2_OIS1N_Reset;
    /* ״̬ */
    tmpcr2 |= TIM_OCInitStruct->TIM_OCIdleState;
    /*  N ״̬ */
    tmpcr2 |= TIM_OCInitStruct->TIM_OCNIdleState;
  }
  /* д TIMx CR2(ƼĴ2) */
  TIMx->CR2 = tmpcr2;
  
  /* д TIMx CCMR1(/ȽģʽĴ1) */
  TIMx->CCMR1 = tmpccmrx;
  
  /* д TIMx CCER(/ȽʹܼĴ) */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIM_OCInitStruct еضʼTIMxͨ2.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCInitStruct: ָһضTIMxϢ TIM_OCInitTypeDef ṹָ.
  * @  û
  */
void TIM_OC2Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct)
{
  uint16_t tmpccmrx = 0, tmpccer = 0, tmpcr2 = 0;
   
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx)); 
  assert_param(IS_TIM_OC_MODE(TIM_OCInitStruct->TIM_OCMode));
  assert_param(IS_TIM_OUTPUT_STATE(TIM_OCInitStruct->TIM_OutputState));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCInitStruct->TIM_OCPolarity));   
  /* ʧͨ 2: λ CC2E λ */
  TIMx->CCER &= CCER_CC2E_Reset;
  
  /* õ TIMx CCER(/Ƚʹ) Ĵֵ */  
  tmpccer = TIMx->CCER;
  /* õ TIMx CR2(ƼĴ2) Ĵֵ */
  tmpcr2 =  TIMx->CR2;
  
  /* õ TIMx CCMR1(/Ƚģʽ) Ĵֵ */
  tmpccmrx = TIMx->CCMR1;
    
  /* λȽģʽλ */
  tmpccmrx &= CCMR_OC24M_Mask;
  
  /* ѡȽģʽ */
  tmpccmrx |= (uint16_t)(TIM_OCInitStruct->TIM_OCMode << 8);
  
  /* λԵȼ */
  tmpccer &= CCER_CC2P_Reset;
  /* Ƚϼ */
  tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OCPolarity << 4);
  
  /* ״̬ */
  tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OutputState << 4);
  
  /* òȽϼĴֵ */
  TIMx->CCR2 = TIM_OCInitStruct->TIM_Pulse;
  
  if(((uint32_t) TIMx == TIM1_BASE) || ((uint32_t) TIMx == TIM8_BASE))
  {
    assert_param(IS_TIM_OUTPUTN_STATE(TIM_OCInitStruct->TIM_OutputNState));
    assert_param(IS_TIM_OCN_POLARITY(TIM_OCInitStruct->TIM_OCNPolarity));
    assert_param(IS_TIM_OCNIDLE_STATE(TIM_OCInitStruct->TIM_OCNIdleState));
    assert_param(IS_TIM_OCIDLE_STATE(TIM_OCInitStruct->TIM_OCIdleState));
    
    /* λ N Եȼ */
    tmpccer &= CCER_CC2NP_Reset;
    /*  N  */
    tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OCNPolarity << 4);
    /* λ N ״̬ */
    tmpccer &= CCER_CC2NE_Reset;
    
    /*  N ״̬ */
    tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OutputNState << 4);
    /* λȽϣȽ N ״̬ */
    tmpcr2 &= CR2_OIS2_Reset;
    tmpcr2 &= CR2_OIS2N_Reset;
    /* ״̬ */
    tmpcr2 |= (uint16_t)(TIM_OCInitStruct->TIM_OCIdleState << 2);
    /*  N ״̬ */
    tmpcr2 |= (uint16_t)(TIM_OCInitStruct->TIM_OCNIdleState << 2);
  }
  /* д TIMx CR2(ƼĴ2) */
  TIMx->CR2 = tmpcr2;
  
  /* д TIMx CCMR1(/ȽģʽĴ1) */
  TIMx->CCMR1 = tmpccmrx;
  
  /* д TIMx CCER(/ȽʹܼĴ) */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIM_OCInitStruct еضʼTIMxͨ3.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCInitStruct: ָһضTIMxϢ TIM_OCInitTypeDef ṹָ.
  * @  û
  */
void TIM_OC3Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct)
{
  uint16_t tmpccmrx = 0, tmpccer = 0, tmpcr2 = 0;
   
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx)); 
  assert_param(IS_TIM_OC_MODE(TIM_OCInitStruct->TIM_OCMode));
  assert_param(IS_TIM_OUTPUT_STATE(TIM_OCInitStruct->TIM_OutputState));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCInitStruct->TIM_OCPolarity));   
  /* ʧ 3: λ CC3E λ */
  TIMx->CCER &= CCER_CC3E_Reset;
  
  /* õ TIMx CCER(/Ƚʹ) Ĵֵ */
  tmpccer = TIMx->CCER;
  /* õ TIMx CR2(ƼĴ2) Ĵֵ */
  tmpcr2 =  TIMx->CR2;
  
  /* õ TIMx CCMR2(/Ƚģʽ) Ĵֵ */
  tmpccmrx = TIMx->CCMR2;
    
  /* λȽģʽλ */
  tmpccmrx &= CCMR_OC13M_Mask;
  
  /* ѡȽģʽ */
  tmpccmrx |= TIM_OCInitStruct->TIM_OCMode;
  
  /* λԵȼ */
  tmpccer &= CCER_CC3P_Reset;
  /* Ƚϼ */
  tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OCPolarity << 8);
  
  /* ״̬ */
  tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OutputState << 8);
  
  /* òȽϼĴֵ */
  TIMx->CCR3 = TIM_OCInitStruct->TIM_Pulse;
  
  if(((uint32_t) TIMx == TIM1_BASE) || ((uint32_t) TIMx == TIM8_BASE))
  {
    assert_param(IS_TIM_OUTPUTN_STATE(TIM_OCInitStruct->TIM_OutputNState));
    assert_param(IS_TIM_OCN_POLARITY(TIM_OCInitStruct->TIM_OCNPolarity));
    assert_param(IS_TIM_OCNIDLE_STATE(TIM_OCInitStruct->TIM_OCNIdleState));
    assert_param(IS_TIM_OCIDLE_STATE(TIM_OCInitStruct->TIM_OCIdleState));
    
    /* λ N Եȼ */
    tmpccer &= CCER_CC3NP_Reset;
    /*  N  */
    tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OCNPolarity << 8);
    /* λ N ״̬ */
    tmpccer &= CCER_CC3NE_Reset;
    
    /*  N ״̬ */
    tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OutputNState << 8);
    /* λȽϣȽ N ״̬ */
    tmpcr2 &= CR2_OIS3_Reset;
    tmpcr2 &= CR2_OIS3N_Reset;
    /* ״̬ */
    tmpcr2 |= (uint16_t)(TIM_OCInitStruct->TIM_OCIdleState << 4);
    /*  N ״̬ */
    tmpcr2 |= (uint16_t)(TIM_OCInitStruct->TIM_OCNIdleState << 4);
  }
  /* д TIMx CR2(ƼĴ2) */
  TIMx->CR2 = tmpcr2;
  
  /* д TIMx CCMR2(/ȽģʽĴ2) */
  TIMx->CCMR2 = tmpccmrx;
  
  /* д TIMx CCER(/ȽʹܼĴ) */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIM_OCInitStruct еضʼTIMxͨ4.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCInitStruct: ָһضTIMxϢ TIM_OCInitTypeDef ṹָ.
  * @  û
  */
void TIM_OC4Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct)
{
  uint16_t tmpccmrx = 0, tmpccer = 0, tmpcr2 = 0;
   
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx)); 
  assert_param(IS_TIM_OC_MODE(TIM_OCInitStruct->TIM_OCMode));
  assert_param(IS_TIM_OUTPUT_STATE(TIM_OCInitStruct->TIM_OutputState));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCInitStruct->TIM_OCPolarity));   
  /* ʧͨ 4: λ CC4E λ */
  TIMx->CCER &= CCER_CC4E_Reset;
  
  /* õ TIMx CCER(/Ƚʹ) Ĵֵ */
  tmpccer = TIMx->CCER;
  /* õ TIMx CR2(ƼĴ2) Ĵֵ */
  tmpcr2 =  TIMx->CR2;
  
  /* õ TIMx CCMR2(/Ƚģʽ) Ĵֵ */
  tmpccmrx = TIMx->CCMR2;
    
  /* λȽģʽλ */
  tmpccmrx &= CCMR_OC24M_Mask;
  
  /* ѡȽģʽ */
  tmpccmrx |= (uint16_t)(TIM_OCInitStruct->TIM_OCMode << 8);
  
  /* λԵȼ */
  tmpccer &= CCER_CC4P_Reset;
  /* Ƚϼ */
  tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OCPolarity << 12);
  
  /* ״̬ */
  tmpccer |= (uint16_t)(TIM_OCInitStruct->TIM_OutputState << 12);
  
  /* òȽϼĴֵ */
  TIMx->CCR4 = TIM_OCInitStruct->TIM_Pulse;
  
  if(((uint32_t) TIMx == TIM1_BASE) || ((uint32_t) TIMx == TIM8_BASE))
  {
    assert_param(IS_TIM_OCIDLE_STATE(TIM_OCInitStruct->TIM_OCIdleState));
    /* λȽϿ״̬ */
    tmpcr2 &= CR2_OIS4_Reset;
    /* ״̬ */
    tmpcr2 |= (uint16_t)(TIM_OCInitStruct->TIM_OCIdleState << 6);
  }
  /* д TIMx CR2(ƼĴ2) */
  TIMx->CR2 = tmpcr2;
  
  /* д TIMx CCMR2(/ȽģʽĴ2) */  
  TIMx->CCMR2 = tmpccmrx;
  
  /* д TIMx CCER(/ȽʹܼĴ) */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIM_ ICInitStruct еضʼ TIMx.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICInitStruct: ָһض TIMx Ϣ TIM_OCInitTypeDef ṹָ.
  * @  û
  */
void TIM_ICInit(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_CHANNEL(TIM_ICInitStruct->TIM_Channel));
  assert_param(IS_TIM_IC_POLARITY(TIM_ICInitStruct->TIM_ICPolarity));
  assert_param(IS_TIM_IC_SELECTION(TIM_ICInitStruct->TIM_ICSelection));
  assert_param(IS_TIM_IC_PRESCALER(TIM_ICInitStruct->TIM_ICPrescaler));
  assert_param(IS_TIM_IC_FILTER(TIM_ICInitStruct->TIM_ICFilter));
  
  if (TIM_ICInitStruct->TIM_Channel == TIM_Channel_1)
  {
    /* TI1  */
    TI1_Config(TIMx, TIM_ICInitStruct->TIM_ICPolarity,
               TIM_ICInitStruct->TIM_ICSelection,
               TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC1Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
  }
  else if (TIM_ICInitStruct->TIM_Channel == TIM_Channel_2)
  {
    /* TI2  */
    TI2_Config(TIMx, TIM_ICInitStruct->TIM_ICPolarity,
               TIM_ICInitStruct->TIM_ICSelection,
               TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC2Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
  }
  else if (TIM_ICInitStruct->TIM_Channel == TIM_Channel_3)
  {
    /* TI3  */
    TI3_Config(TIMx,  TIM_ICInitStruct->TIM_ICPolarity,
               TIM_ICInitStruct->TIM_ICSelection,
               TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC3Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
  }
  else
  {
    /* TI4  */
    TI4_Config(TIMx, TIM_ICInitStruct->TIM_ICPolarity,
               TIM_ICInitStruct->TIM_ICSelection,
               TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC4Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
  }
}

/**
  * @  TIM_ICInitStructָĲTIM豸ȥⲿPWMź.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICInitStruct: ָһض TIMx Ϣ TIM_ICInitTypeDef ṹָ.
  * @  û
  */
void TIM_PWMIConfig(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct)
{
  uint16_t icoppositepolarity = TIM_ICPolarity_Rising;
  uint16_t icoppositeselection = TIM_ICSelection_DirectTI;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* ѡ෴뼫 */
  if (TIM_ICInitStruct->TIM_ICPolarity == TIM_ICPolarity_Rising)
  {
    icoppositepolarity = TIM_ICPolarity_Falling;
  }
  else
  {
    icoppositepolarity = TIM_ICPolarity_Rising;
  }
  /* ѡ෴ */
  if (TIM_ICInitStruct->TIM_ICSelection == TIM_ICSelection_DirectTI)
  {
    icoppositeselection = TIM_ICSelection_IndirectTI;
  }
  else
  {
    icoppositeselection = TIM_ICSelection_DirectTI;
  }
  if (TIM_ICInitStruct->TIM_Channel == TIM_Channel_1)
  {
    /* TI1  */
    TI1_Config(TIMx, TIM_ICInitStruct->TIM_ICPolarity, TIM_ICInitStruct->TIM_ICSelection,
               TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC1Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
    /* TI2  */
    TI2_Config(TIMx, icoppositepolarity, icoppositeselection, TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC2Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
  }
  else
  { 
    /* TI2  */
    TI2_Config(TIMx, TIM_ICInitStruct->TIM_ICPolarity, TIM_ICInitStruct->TIM_ICSelection,
               TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC2Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
    /* TI1  */
    TI1_Config(TIMx, icoppositepolarity, icoppositeselection, TIM_ICInitStruct->TIM_ICFilter);
    /* 벶׽ԤƵֵ */
    TIM_SetIC1Prescaler(TIMx, TIM_ICInitStruct->TIM_ICPrescaler);
  }
}

/**
  * @  : ɲԣʱ䣬ƽOSSIOSSR״̬AOE(Զʹ).
  * @  TIMx: ˴x18ѡ
  * @  TIM_BDTRInitStruct: ָһض TIMx Ϣ TIM_BDTRInitTypeDef ṹָ.
  * @  û
  */
void TIM_BDTRConfig(TIM_TypeDef* TIMx, TIM_BDTRInitTypeDef *TIM_BDTRInitStruct)
{
  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_TIM_OSSR_STATE(TIM_BDTRInitStruct->TIM_OSSRState));
  assert_param(IS_TIM_OSSI_STATE(TIM_BDTRInitStruct->TIM_OSSIState));
  assert_param(IS_TIM_LOCK_LEVEL(TIM_BDTRInitStruct->TIM_LOCKLevel));
  assert_param(IS_TIM_BREAK_STATE(TIM_BDTRInitStruct->TIM_Break));
  assert_param(IS_TIM_BREAK_POLARITY(TIM_BDTRInitStruct->TIM_BreakPolarity));
  assert_param(IS_TIM_AUTOMATIC_OUTPUT_STATE(TIM_BDTRInitStruct->TIM_AutomaticOutput));
  /* ãƽ𣬼λͼԣOSSR״̬OSSI״̬ͺʱԶʹλ */
  TIMx->BDTR = (uint32_t)TIM_BDTRInitStruct->TIM_OSSRState | TIM_BDTRInitStruct->TIM_OSSIState |
             TIM_BDTRInitStruct->TIM_LOCKLevel | TIM_BDTRInitStruct->TIM_DeadTime |
             TIM_BDTRInitStruct->TIM_Break | TIM_BDTRInitStruct->TIM_BreakPolarity |
             TIM_BDTRInitStruct->TIM_AutomaticOutput;
}

/**
  * @   TIM1_TimeBaseInitStruct еÿһȱʡֵ.
  * @  TIM_TimeBaseInitStruct : ָһʼ TIM_TimeBaseInitTypeDef ṹָ.
  * @  û
  */
void TIM_TimeBaseStructInit(TIM_TimeBaseInitTypeDef* TIM_TimeBaseInitStruct)
{
  /* óĬ */
  TIM_TimeBaseInitStruct->TIM_Period = 0xFFFF;
  TIM_TimeBaseInitStruct->TIM_Prescaler = 0x0000;
  TIM_TimeBaseInitStruct->TIM_ClockDivision = TIM_CKD_DIV1;
  TIM_TimeBaseInitStruct->TIM_CounterMode = TIM_CounterMode_Up;
  TIM_TimeBaseInitStruct->TIM_RepetitionCounter = 0x0000;
}

/**
  * @   TIM1_OCInitStruct еÿһȱʡֵ.
  * @  TIM_OCInitStruct : ָһʼ TIM_OCInitStruct ṹָ.
  * @  û
  */
void TIM_OCStructInit(TIM_OCInitTypeDef* TIM_OCInitStruct)
{
  /* óĬ */
  TIM_OCInitStruct->TIM_OCMode = TIM_OCMode_Timing;
  TIM_OCInitStruct->TIM_OutputState = TIM_OutputState_Disable;
  TIM_OCInitStruct->TIM_OutputNState = TIM_OutputNState_Disable;
  TIM_OCInitStruct->TIM_Pulse = 0x0000;
  TIM_OCInitStruct->TIM_OCPolarity = TIM_OCPolarity_High;
  TIM_OCInitStruct->TIM_OCNPolarity = TIM_OCPolarity_High;
  TIM_OCInitStruct->TIM_OCIdleState = TIM_OCIdleState_Reset;
  TIM_OCInitStruct->TIM_OCNIdleState = TIM_OCNIdleState_Reset;
}

/**
  * @   TIM1_ICInitStruct еÿһȱʡֵ.
  * @  TIM_ICInitStruct : ָһʼ TIM_ICInitStruct ṹָ.
  * @  û
  */
void TIM_ICStructInit(TIM_ICInitTypeDef* TIM_ICInitStruct)
{
  /* óĬ */
  TIM_ICInitStruct->TIM_Channel = TIM_Channel_1;
  TIM_ICInitStruct->TIM_ICPolarity = TIM_ICPolarity_Rising;
  TIM_ICInitStruct->TIM_ICSelection = TIM_ICSelection_DirectTI;
  TIM_ICInitStruct->TIM_ICPrescaler = TIM_ICPSC_DIV1;
  TIM_ICInitStruct->TIM_ICFilter = 0x00;
}

/**
  * @   TIM1_BDTRInitStruct еÿһȱʡֵ.
  * @  TIM_BDTRInitStruct: ָһʼ TIM1_BDTRInitStruct ṹ.
  * @  û
  */
void TIM_BDTRStructInit(TIM_BDTRInitTypeDef* TIM_BDTRInitStruct)
{
  /* óĬ */
  TIM_BDTRInitStruct->TIM_OSSRState = TIM_OSSRState_Disable;
  TIM_BDTRInitStruct->TIM_OSSIState = TIM_OSSIState_Disable;
  TIM_BDTRInitStruct->TIM_LOCKLevel = TIM_LOCKLevel_OFF;
  TIM_BDTRInitStruct->TIM_DeadTime = 0x00;
  TIM_BDTRInitStruct->TIM_Break = TIM_Break_Disable;
  TIM_BDTRInitStruct->TIM_BreakPolarity = TIM_BreakPolarity_Low;
  TIM_BDTRInitStruct->TIM_AutomaticOutput = TIM_AutomaticOutput_Disable;
}

/**
  * @  ʹܻʧָ TIM .
  * @  TIMx: ˴x18ѡ.
  * @  NewState: TIMx ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_Cmd(TIM_TypeDef* TIMx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  
  if (NewState != DISABLE)
  {
    /* ʹ TIM  */
    TIMx->CR1 |= CR1_CEN_Set;
  }
  else
  {
    /* ʧ TIM  */
    TIMx->CR1 &= CR1_CEN_Reset;
  }
}

/**
  * @  ʹܻʧ TIM Χ.
  * @  TIMx: ˴x18ѡ.
  * @  NewState: TIM Χ״̬.
  *                  : ENABLE or DISABLE.
  * @  û
  */
void TIM_CtrlPWMOutputs(TIM_TypeDef* TIMx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ʹ TIM  */
    TIMx->BDTR |= BDTR_MOE_Set;
  }
  else
  {
    /* ʧ TIM  */
    TIMx->BDTR &= BDTR_MOE_Reset;
  }  
}

/**
  * @  ʹܻʧָ TIM ж.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_IT: ʹܻʧܵ TIM жԴ.
  *                ȡֵ֮һ:
  *                TIM_IT_Update:  TIM жԴ
  *                TIM_IT_CC1:     TIM /Ƚ 1 жԴ
  *                TIM_IT_CC2:     TIM /Ƚ 2 жԴ
  *                TIM_IT_CC3:     TIM /Ƚ 3 жԴ
  *                TIM_IT_CC4:     TIM /Ƚ 4 жԴ
  *                TIM_IT_COM:     TIM COMжԴ
  *                TIM_IT_Trigger: TIM жԴ
  *                TIM_IT_Break:   TIM ɲжԴ
  * @ע 
  *   - TIM6  TIM7 ֻܲУж. 
  *   - TIM_IT_COM  TIM_IT_Break ֻܺ TIM1  TIM8 һʹ.  
  * @  NewState: TIM жϵ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_ITConfig(TIM_TypeDef* TIMx, uint16_t TIM_IT, FunctionalState NewState)
{  
  /* s */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_IT(TIM_IT));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  
  if (NewState != DISABLE)
  {
    /* ʹжԴ */
    TIMx->DIER |= TIM_IT;
  }
  else
  {
    /* ʧжԴ */
    TIMx->DIER &= (uint16_t)~TIM_IT;
  }
}

/**
  * @  ý TIM ¼.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_EventSource: ָ¼Դ.
  *                         ȡһֵ:	   
  *          TIM_EventSource_Update: ʱ¼Դ
  *          TIM_EventSource_CC1:     ʱ׽Ƚ 1 ¼Դ
  *          TIM_EventSource_CC2:     ʱ׽Ƚ 2 ¼Դ
  *          TIM_EventSource_CC3:     ʱ׽Ƚ 3 ¼Դ
  *          TIM_EventSource_CC4:     ʱ׽Ƚ 4 ¼Դ
  *          TIM_EventSource_COM:     ʱ COM ¼Դ  
  *          TIM_EventSource_Trigger: ʱ¼Դ
  *          TIM_EventSource_Break:   ʱɲ¼Դ
  * @ע 
  *   - TIM6  TIM7 ֻܲУж. 
  *   - TIM_IT_COM  TIM_IT_Break ֻܺ TIM1  TIM8 һʹ. 
  * @  û
  */
void TIM_GenerateEvent(TIM_TypeDef* TIMx, uint16_t TIM_EventSource)
{ 
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_EVENT_SOURCE(TIM_EventSource));
  
  /* ¼Դ */
  TIMx->EGR = TIM_EventSource;
}

/**
  * @   TIMx DMAӿ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_DMABase: DMA ַ.
  *                     ȡֵ֮һ:
  *   TIM_DMABase_CR, TIM_DMABase_CR2, TIM_DMABase_SMCR,
  *   TIM_DMABase_DIER, TIM1_DMABase_SR, TIM_DMABase_EGR,
  *   TIM_DMABase_CCMR1, TIM_DMABase_CCMR2, TIM_DMABase_CCER,
  *   TIM_DMABase_CNT, TIM_DMABase_PSC, TIM_DMABase_ARR,
  *   TIM_DMABase_RCR, TIM_DMABase_CCR1, TIM_DMABase_CCR2,
  *   TIM_DMABase_CCR3, TIM_DMABase_CCR4, TIM_DMABase_BDTR,
  *   TIM_DMABase_DCR.
  * @  TIM_DMABurstLength: DMA 崮.
  *                            ȡֵ֮һ:
  *        TIM_DMABurstLength_1Byte  TIM_DMABurstLength_18Bytes.
  * @  û
  */
void TIM_DMAConfig(TIM_TypeDef* TIMx, uint16_t TIM_DMABase, uint16_t TIM_DMABurstLength)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_DMA_BASE(TIM_DMABase));
  assert_param(IS_TIM_DMA_LENGTH(TIM_DMABurstLength));
  /*  DMA ַ DMA 崮 */
  TIMx->DCR = TIM_DMABase | TIM_DMABurstLength;
}

/**
  * @  ʹܻʧ TIMx  DMA .
  * @  TIMx: ˴x18ѡ. 
  * @  TIM_DMASource: ָ DMA Դ.
  *                       κֵ:
  *                       TIM_DMA_Update:  TIM жԴ
  *                       TIM_DMA_CC1:     TIM Ƚ 1 DMA Դ
  *                       TIM_DMA_CC2:     TIM Ƚ 2 DMA Դ
  *                       TIM_DMA_CC3:     TIM Ƚ 3 DMA Դ
  *                       TIM_DMA_CC4:     TIM Ƚ 4 DMA Դ
  *                       TIM_DMA_COM:     TIM COM DMA Դ
  *                       TIM_DMA_Trigger: TIM  DMA Դ
  * @  NewState: DMA ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_DMACmd(TIM_TypeDef* TIMx, uint16_t TIM_DMASource, FunctionalState NewState)
{ 
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_DMA_SOURCE(TIM_DMASource));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  
  if (NewState != DISABLE)
  {
    /* ʹ DMA Դ */
    TIMx->DIER |= TIM_DMASource; 
  }
  else
  {
    /* ʧ DMA Դ */
    TIMx->DIER &= (uint16_t)~TIM_DMASource;
  }
}

/**
  * @   TIMx ڲʱ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  û
  */
void TIM_InternalClockConfig(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* ʧڲʱԤƵģʽ */
  TIMx->SMCR &=  SMCR_SMS_Mask;
}

/**
  * @   TIMx ڲΪⲿʱģʽ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ITRSource: .
  *                       ȡֵ֮һ:
  *                       TIM_TS_ITR0: ڲ 0
  *                       TIM_TS_ITR1: ڲ 1
  *                       TIM_TS_ITR2: ڲ 2
  *                       TIM_TS_ITR3: ڲ 3
  * @  û
  */
void TIM_ITRxExternalClockConfig(TIM_TypeDef* TIMx, uint16_t TIM_InputTriggerSource)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_INTERNAL_TRIGGER_SELECTION(TIM_InputTriggerSource));
  /* ѡڲ */
  TIM_SelectInputTrigger(TIMx, TIM_InputTriggerSource);
  /* ѡⲿʱģʽ1 */
  TIMx->SMCR |= TIM_SlaveMode_External1;
}

/**
  * @   TIMx Ϊⲿʱ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_TIxExternalCLKSource: .
  *          ȡֵ֮һ:
  *          TIM_TIxExternalCLK1Source_TI1ED: TI1 Ե
  *          TIM_TIxExternalCLK1Source_TI1: ɸѡĶʱ 1
  *          TIM_TIxExternalCLK1Source_TI2: ɸѡĶʱ 2
  * @  TIM_ICPolarity: ָ TIx .
  *          ȡֵ֮һ:
  *          TIM_ICPolarity_Rising
  *          TIM_ICPolarity_Falling
  * @  ICFilter : ָ벶.
  *                   ò0x00xFֵ֮.
  * @  û
  */
void TIM_TIxExternalClockConfig(TIM_TypeDef* TIMx, uint16_t TIM_TIxExternalCLKSource,
                                uint16_t TIM_ICPolarity, uint16_t ICFilter)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_TIXCLK_SOURCE(TIM_TIxExternalCLKSource));
  assert_param(IS_TIM_IC_POLARITY(TIM_ICPolarity));
  assert_param(IS_TIM_IC_FILTER(ICFilter));
  /* öʱʱԴ */
  if (TIM_TIxExternalCLKSource == TIM_TIxExternalCLK1Source_TI2)
  {
    TI2_Config(TIMx, TIM_ICPolarity, TIM_ICSelection_DirectTI, ICFilter);
  }
  else
  {
    TI1_Config(TIMx, TIM_ICPolarity, TIM_ICSelection_DirectTI, ICFilter);
  }
  /* ѡ񴥷 */
  TIM_SelectInputTrigger(TIMx, TIM_TIxExternalCLKSource);
  /* ѡⲿʱģʽ1 */
  TIMx->SMCR |= TIM_SlaveMode_External1;
}

/**
  * @  ⲿʱģʽ1
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ExtTRGPrescaler: ⲿԤƵ.
  *          ȡֵ֮һ:
  *          TIM_ExtTRGPSC_OFF:  ETRP ԤƵ .
  *          TIM_ExtTRGPSC_DIV2: ETRP Ƶʳ 2.
  *          TIM_ExtTRGPSC_DIV4: ETRP Ƶʳ 4.
  *          TIM_ExtTRGPSC_DIV8: ETRP Ƶʳ 8.
  * @  TIM_ExtTRGPolarity: ⲿ.
  *          ȡֵ֮һ:
  *          TIM_ExtTRGPolarity_Inverted:    ͵ƽ½.
  *          TIM_ExtTRGPolarity_NonInverted: ߵƽ.
  * @  ExtTRGFilter: ⲿ.
  *          ò0x00xFֵ֮
  * @  û
  */ 
void TIM_ETRClockMode1Config(TIM_TypeDef* TIMx, uint16_t TIM_ExtTRGPrescaler, uint16_t TIM_ExtTRGPolarity,
                             uint16_t ExtTRGFilter)
{
  uint16_t tmpsmcr = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_EXT_PRESCALER(TIM_ExtTRGPrescaler));
  assert_param(IS_TIM_EXT_POLARITY(TIM_ExtTRGPolarity));
  assert_param(IS_TIM_EXT_FILTER(ExtTRGFilter));
  /*  ETR ʱԴ */
  TIM_ETRConfig(TIMx, TIM_ExtTRGPrescaler, TIM_ExtTRGPolarity, ExtTRGFilter);
  
  /* õ TIMx SMCR(ģʽ) Ĵֵ */
  tmpsmcr = TIMx->SMCR;
  /* λ SMS(ģʽѡ) λ */
  tmpsmcr &= SMCR_SMS_Mask;
  /* ѡⲿʱģʽ1 */
  tmpsmcr |= TIM_SlaveMode_External1;
  /* ѡ񴥷 ѡ : ETRF */
  tmpsmcr &= SMCR_TS_Mask;
  tmpsmcr |= TIM_TS_ETRF;
  /* д TIMx SMCR */
  TIMx->SMCR = tmpsmcr;
}

/**
  * @  ⲿʱģʽ2
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ExtTRGPrescaler: ⲿԤƵ.
  *          ֵ֮һ:
  *          TIM_ExtTRGPSC_OFF:  ETRP ԤƵ .
  *          TIM_ExtTRGPSC_DIV2: ETRP Ƶʳ 2.
  *          TIM_ExtTRGPSC_DIV4: ETRP Ƶʳ 4.
  *          TIM_ExtTRGPSC_DIV8: ETRP Ƶʳ 8.
  * @  TIM_ExtTRGPolarity: ⲿ.
  *          ֵ֮һ:
  *          TIM_ExtTRGPolarity_Inverted:    ͵ƽ½.
  *          TIM_ExtTRGPolarity_NonInverted: ߵƽ.
  * @  ExtTRGFilter: ⲿ.
  *          ò0x00xFֵ֮
  * @  û
  */
void TIM_ETRClockMode2Config(TIM_TypeDef* TIMx, uint16_t TIM_ExtTRGPrescaler, 
                             uint16_t TIM_ExtTRGPolarity, uint16_t ExtTRGFilter)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_EXT_PRESCALER(TIM_ExtTRGPrescaler));
  assert_param(IS_TIM_EXT_POLARITY(TIM_ExtTRGPolarity));
  assert_param(IS_TIM_EXT_FILTER(ExtTRGFilter));
  /*  ETR ʱԴ */
  TIM_ETRConfig(TIMx, TIM_ExtTRGPrescaler, TIM_ExtTRGPolarity, ExtTRGFilter);
  /* ʹⲿʱģʽ2 */
  TIMx->SMCR |= SMCR_ECE_Set;
}

/**
  * @   TIMx ⲿ (ETR).
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ExtTRGPrescaler: ⲿԤƵ.
  *          ֵ֮һ:
  *          TIM_ExtTRGPSC_OFF:  ETRP ԤƵ .
  *          TIM_ExtTRGPSC_DIV2: ETRP Ƶʳ 2.
  *          TIM_ExtTRGPSC_DIV4: ETRP Ƶʳ 4.
  *          TIM_ExtTRGPSC_DIV8: ETRP Ƶʳ 8.
  * @  TIM_ExtTRGPolarity: ⲿ.
  *          ֵ֮һ:
  *          TIM_ExtTRGPolarity_Inverted:    ͵ƽ½.
  *          TIM_ExtTRGPolarity_NonInverted: ߵƽ.
  * @  ExtTRGFilter: ⲿ.
  *          ò0x00xFֵ֮
  * @  û
  */
void TIM_ETRConfig(TIM_TypeDef* TIMx, uint16_t TIM_ExtTRGPrescaler, uint16_t TIM_ExtTRGPolarity,
                   uint16_t ExtTRGFilter)
{
  uint16_t tmpsmcr = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_EXT_PRESCALER(TIM_ExtTRGPrescaler));
  assert_param(IS_TIM_EXT_POLARITY(TIM_ExtTRGPolarity));
  assert_param(IS_TIM_EXT_FILTER(ExtTRGFilter));
  tmpsmcr = TIMx->SMCR;
  /* λ ETR λ */
  tmpsmcr &= SMCR_ETR_Mask;
  /* ԤƵֵͼ */
  tmpsmcr |= (uint16_t)(TIM_ExtTRGPrescaler | (uint16_t)(TIM_ExtTRGPolarity | (uint16_t)(ExtTRGFilter << (uint16_t)8)));
  /* дTIMx SMCR */
  TIMx->SMCR = tmpsmcr;
}

/**
  * @   TIMx ԤƵ.
  * @  TIMx: ˴x18ѡ.
  * @  Prescaler: ָԤƵֵ
  * @  TIM_PSCReloadMode: ָԤƵģʽ
  *          ȡֵ֮һ:
  *          TIM_PSCReloadMode_Update:    TIM ԤƵֵڸ¼װ.
  *          TIM_PSCReloadMode_Immediate: TIM ԤƵֵʱװ.
  * @  û
  */
void TIM_PrescalerConfig(TIM_TypeDef* TIMx, uint16_t Prescaler, uint16_t TIM_PSCReloadMode)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_PRESCALER_RELOAD(TIM_PSCReloadMode));
  /* ԤƵֵ */
  TIMx->PSC = Prescaler;
  /*   λ UG λ */
  TIMx->EGR = TIM_PSCReloadMode;
}

/**
  * @  ָ TIMx ģʽ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_CounterMode: ʹõļģʽ
  *          ȡֵ֮һ:
  *          TIM_CounterMode_Up:             TIM ϼģʽ
  *          TIM_CounterMode_Down:           TIM ¼ģʽ
  *          TIM_CounterMode_CenterAligned1: TIM Ķģʽ1
  *          TIM_CounterMode_CenterAligned2: TIM Ķģʽ2
  *          TIM_CounterMode_CenterAligned3: TIM Ķģʽ3
  * @  û
  */
void TIM_CounterModeConfig(TIM_TypeDef* TIMx, uint16_t TIM_CounterMode)
{
  uint16_t tmpcr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_COUNTER_MODE(TIM_CounterMode));
  tmpcr1 = TIMx->CR1;
  /* λ CMS  DIR λ */
  tmpcr1 &= CR1_CounterMode_Mask;
  /* üģʽ */
  tmpcr1 |= TIM_CounterMode;
  /* д TIMx CR1 Ĵ */
  TIMx->CR1 = tmpcr1;
}

/**
  * @  ѡ봥Դ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_InputTriggerSource: 봥Դ.
  *          ȡֵ֮һ:
  *          TIM_TS_ITR0:    ڲ 0
  *          TIM_TS_ITR1:    ڲ 1
  *          TIM_TS_ITR2:    ڲ 2
  *          TIM_TS_ITR3:    ڲ 3
  *          TIM_TS_TI1F_ED: TI1 Ե
  *          TIM_TS_TI1FP1:  ʱ 1
  *          TIM_TS_TI2FP2:  ʱ 2
  *          TIM_TS_ETRF:    ⲿ
  * @  û
  */
void TIM_SelectInputTrigger(TIM_TypeDef* TIMx, uint16_t TIM_InputTriggerSource)
{
  uint16_t tmpsmcr = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_TRIGGER_SELECTION(TIM_InputTriggerSource));
  /* õ TIMx SMCR Ĵֵ */
  tmpsmcr = TIMx->SMCR;
  /* λ TS λ */
  tmpsmcr &= SMCR_TS_Mask;
  /* 봥Դ */
  tmpsmcr |= TIM_InputTriggerSource;
  /* д TIMx SMCR */
  TIMx->SMCR = tmpsmcr;
}

/**
  * @   TIMx .
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_EncoderMode: ָ TIMx ģʽ.
  *          ȡֵ֮һ:
  *          TIM_EncoderMode_TI1:  TIMʹģʽ1.
  *          TIM_EncoderMode_TI2:  TIMʹģʽ2.
  *          TIM_EncoderMode_TI12: TIMʹģʽ3.
  * @  TIM_IC1Polarity: ָ IC1 
  *          ȡֵ֮һ:
  *          TIM_ICPolarity_Falling: IC ½.
  *          TIM_ICPolarity_Rising:  IC .
  * @  TIM_IC2Polarity: ָ IC2 
  *          ȡֵ֮һ:
  *          TIM_ICPolarity_Falling: IC ½.
  *          TIM_ICPolarity_Rising:  IC .
  * @  û
  */
void TIM_EncoderInterfaceConfig(TIM_TypeDef* TIMx, uint16_t TIM_EncoderMode,
                                uint16_t TIM_IC1Polarity, uint16_t TIM_IC2Polarity)
{
  uint16_t tmpsmcr = 0;
  uint16_t tmpccmr1 = 0;
  uint16_t tmpccer = 0;
    
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_ENCODER_MODE(TIM_EncoderMode));
  assert_param(IS_TIM_IC_POLARITY(TIM_IC1Polarity));
  assert_param(IS_TIM_IC_POLARITY(TIM_IC2Polarity));

  /* õ TIMx SMCR Ĵֵ */
  tmpsmcr = TIMx->SMCR;

  /* õ TIMx CCMR1 Ĵֵ */
  tmpccmr1 = TIMx->CCMR1;

  /* õ TIMx CCER Ĵֵ */
  tmpccer = TIMx->CCER;

  /* ñģʽ */
  tmpsmcr &= SMCR_SMS_Mask;
  tmpsmcr |= TIM_EncoderMode;

  /* ѡ񲶻Ƚ 1 ͲȽ 2 Ϊ */
  tmpccmr1 &= CCMR_CC13S_Mask & CCMR_CC24S_Mask;
  tmpccmr1 |= CCMR_TI13Direct_Set | CCMR_TI24Direct_Set;

  /*  TI1  TI2  */
  tmpccer &= CCER_CC1P_Reset & CCER_CC2P_Reset;
  tmpccer |= (uint16_t)(TIM_IC1Polarity | (uint16_t)(TIM_IC2Polarity << (uint16_t)4));

  /* д TIMx SMCR */
  TIMx->SMCR = tmpsmcr;

  /* д TIMx CCMR1 */
  TIMx->CCMR1 = tmpccmr1;

  /* д TIMx CCER */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIMx 1Ϊ߷ǻƽ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ForcedAction: źŵö.
  *          ȡֵ֮һ:
  *          TIM_ForcedAction_Active:   ǿOCxREFΪЧƽ
  *          TIM_ForcedAction_InActive: ǿOCxREFΪЧƽ
  * @  û
  */
void TIM_ForcedOC1Config(TIM_TypeDef* TIMx, uint16_t TIM_ForcedAction)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_FORCED_ACTION(TIM_ForcedAction));
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC1M λ */
  tmpccmr1 &= CCMR_OC13M_Mask;
  /* ǿģʽ */
  tmpccmr1 |= TIM_ForcedAction;
  /* д TIMx CCMR1 Ĵ */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @   TIMx 2Ϊ߷ǻƽ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ForcedAction: źŵö.
  *          ȡֵ֮һ:
  *          TIM_ForcedAction_Active:   ǿOCxREFΪЧƽ
  *          TIM_ForcedAction_InActive: ǿOCxREFΪЧƽ
  * @  û
  */
void TIM_ForcedOC2Config(TIM_TypeDef* TIMx, uint16_t TIM_ForcedAction)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_FORCED_ACTION(TIM_ForcedAction));
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC2M λ */
  tmpccmr1 &= CCMR_OC24M_Mask;
  /* ǿģʽ */
  tmpccmr1 |= (uint16_t)(TIM_ForcedAction << 8);
  /* д TIMx CCMR1 Ĵ */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @   TIMx 3Ϊ߷ǻƽ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ForcedAction: źŵö.
  *          ȡֵ֮һ:
  *          TIM_ForcedAction_Active:   ǿOCxREFΪЧƽ
  *          TIM_ForcedAction_InActive: ǿOCxREFΪЧƽ
  * @  û
  */
void TIM_ForcedOC3Config(TIM_TypeDef* TIMx, uint16_t TIM_ForcedAction)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_FORCED_ACTION(TIM_ForcedAction));
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC1M λ */
  tmpccmr2 &= CCMR_OC13M_Mask;
  /* ǿģʽ */
  tmpccmr2 |= TIM_ForcedAction;
  /* д TIMx CCMR2 Ĵ */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @   TIMx 4Ϊ߷ǻƽ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ForcedAction: źŵö.
  *          ȡֵ֮һ:
  *          TIM_ForcedAction_Active:   ǿOCxREFΪЧƽ
  *          TIM_ForcedAction_InActive: ǿOCxREFΪЧƽ
  * @  û
  */
void TIM_ForcedOC4Config(TIM_TypeDef* TIMx, uint16_t TIM_ForcedAction)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_FORCED_ACTION(TIM_ForcedAction));
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC2M λ */
  tmpccmr2 &= CCMR_OC24M_Mask;
  /* ǿģʽ */
  tmpccmr2 |= (uint16_t)(TIM_ForcedAction << 8);
  /* д TIMx CCMR2 Ĵ */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @  ʹܻʧ TIMx  ARR ϵԤװؼĴ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  NewState: TIM1_CR1ĴеARPEλ״̬
  *                  : ENABLE or DISABLE.
  * @  û
  */
void TIM_ARRPreloadConfig(TIM_TypeDef* TIMx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /*  ARR Ԥװλ */
    TIMx->CR1 |= CR1_ARPE_Set;
  }
  else
  {
    /* λ ARR Ԥװλ */
    TIMx->CR1 &= CR1_ARPE_Reset;
  }
}

/**
  * @  ѡ TIM ͨѶ¼.
  * @  TIMx: ˴x18ѡ
  * @  NewState: ͨѶ¼״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_SelectCOM(TIM_TypeDef* TIMx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /*  COM λ */
    TIMx->CR2 |= CR2_CCUS_Set;
  }
  else
  {
    /* λ COM λ */
    TIMx->CR2 &= CR2_CCUS_Reset;
  }
}

/**
  * @  ѡ TIMx ĲȽ DMA Դ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  NewState: Ƚ DMA Դ״̬
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_SelectCCDMA(TIM_TypeDef* TIMx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /*  CCDS λ */
    TIMx->CR2 |= CR2_CCDS_Set;
  }
  else
  {
    /* λ CCDS λ */
    TIMx->CR2 &= CR2_CCDS_Reset;
  }
}

/**
  * @  û߸λ TIMx ȽϿλ.
  * @  TIMx: ˴x18ѡ
  * @  NewState: ȽԤؿλ״̬
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_CCPreloadControl(TIM_TypeDef* TIMx, FunctionalState NewState)
{ 
  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /*  CCPC λ */
    TIMx->CR2 |= CR2_CCPC_Set;
  }
  else
  {
    /* λ CCPC λ */
    TIMx->CR2 &= CR2_CCPC_Reset;
  }
}

/**
  * @  ʹܻʧ TIMx  CCR1 ϵԤװؼĴ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPreload: ȽԤװ״̬
  *                       ȡֵ֮һ:
  *                       TIM_OCPreload_Enable
  *                       TIM_OCPreload_Disable
  * @  û
  */
void TIM_OC1PreloadConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPreload)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCPRELOAD_STATE(TIM_OCPreload));
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC1PE λ */
  tmpccmr1 &= CCMR_OC13PE_Reset;
  /* ʹܻʧԤװؼĴ */
  tmpccmr1 |= TIM_OCPreload;
  /* д TIMx CCMR1 Ĵ */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @  ʹܻʧ TIMx  CCR2 ϵԤװؼĴ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPreload: ȽԤװ״̬
  *                       ȡֵ֮һ:
  *                       TIM_OCPreload_Enable
  *                       TIM_OCPreload_Disable
  * @  û
  */
void TIM_OC2PreloadConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPreload)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCPRELOAD_STATE(TIM_OCPreload));
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC2PE λ */
  tmpccmr1 &= CCMR_OC24PE_Reset;
  /* ʹܻʧԤװؼĴ */
  tmpccmr1 |= (uint16_t)(TIM_OCPreload << 8);
  /* д TIMx CCMR1 Ĵ */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @  ʹܻʧ TIMx  CCR3 ϵԤװؼĴ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPreload: ȽԤװ״̬
  *                       ȡֵ֮һ:
  *                       TIM_OCPreload_Enable
  *                       TIM_OCPreload_Disable
  * @  û
  */
void TIM_OC3PreloadConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPreload)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCPRELOAD_STATE(TIM_OCPreload));
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC3PE λ */
  tmpccmr2 &= CCMR_OC13PE_Reset;
  /* ʹܻʧԤװؼĴ */
  tmpccmr2 |= TIM_OCPreload;
  /* д TIMx CCMR2 Ĵ */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @  ʹܻʧ TIMx  CCR4 ϵԤװؼĴ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPreload: ȽԤװ״̬
  *                       ȡֵ֮һ:
  *                       TIM_OCPreload_Enable
  *                       TIM_OCPreload_Disable
  * @  û
  */
void TIM_OC4PreloadConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPreload)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCPRELOAD_STATE(TIM_OCPreload));
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC4PE λ */
  tmpccmr2 &= CCMR_OC24PE_Reset;
  /* ʹܻʧԤװؼĴ */
  tmpccmr2 |= (uint16_t)(TIM_OCPreload << 8);
  /* д TIMx CCMR2 Ĵ */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @   TIMx Ƚ1.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCFast: ȽϿ״̬.
  *                    ȡֵ֮һ:
  *                    TIM_OCFast_Enable:  TIM ȽϿʹ
  *                    TIM_OCFast_Disable: TIM ȽϿʧ
  * @  û
  */
void TIM_OC1FastConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCFast)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCFAST_STATE(TIM_OCFast));
  /* õ TIMx CCMR1 Ĵֵ */
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC1FE λ */
  tmpccmr1 &= CCMR_OC13FE_Reset;
  /* ʹܻʧܲȽϿ */
  tmpccmr1 |= TIM_OCFast;
  /* д TIMx CCMR1 */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @   TIMx Ƚ2.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCFast: ȽϿ״̬.
  *                    ȡֵ֮һ:
  *                    TIM_OCFast_Enable:  TIM ȽϿʹ
  *                    TIM_OCFast_Disable: TIM ȽϿʧ
  * @  û
  */
void TIM_OC2FastConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCFast)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCFAST_STATE(TIM_OCFast));
  /* õ TIMx CCMR1 Ĵֵ */
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC2FE λ */
  tmpccmr1 &= CCMR_OC24FE_Reset;
  /* ʹܻʧܲȽϿ */
  tmpccmr1 |= (uint16_t)(TIM_OCFast << 8);
  /* д TIMx CCMR1 */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @   TIMx Ƚ3.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCFast: ȽϿ״̬.
  *                    ȡֵ֮һ:
  *                    TIM_OCFast_Enable:  TIM ȽϿʹ
  *                    TIM_OCFast_Disable: TIM ȽϿʧ
  * @  û
  */
void TIM_OC3FastConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCFast)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCFAST_STATE(TIM_OCFast));
  /* õ TIMx CCMR2 Ĵֵ */
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC3FE λ */
  tmpccmr2 &= CCMR_OC13FE_Reset;
  /* ʹܻʧܲȽϿ */
  tmpccmr2 |= TIM_OCFast;
  /* д TIMx CCMR2 */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @   TIMx Ƚ4.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCFast: ȽϿ״̬.
  *                    ȡֵ֮һ:
  *                    TIM_OCFast_Enable:  TIM ȽϿʹ
  *                    TIM_OCFast_Disable: TIM ȽϿʧ
  * @  û
  */
void TIM_OC4FastConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCFast)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCFAST_STATE(TIM_OCFast));
  /* õ TIMx CCMR2 Ĵֵ */
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC4FE λ */
  tmpccmr2 &= CCMR_OC24FE_Reset;
  /* ʹܻʧܲȽϿ */
  tmpccmr2 |= (uint16_t)(TIM_OCFast << 8);
  /* д TIMx CCMR2 */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @  һⲿ¼ʱ߱ OCREF1 ź
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCClear: Ƚʹλ״̬.
  *                     ȡֵ֮һ:
  *                     TIM_OCClear_Enable:  TIM Ƚʹ
  *                     TIM_OCClear_Disable: TIM Ƚʧ
  * @  û
  */
void TIM_ClearOC1Ref(TIM_TypeDef* TIMx, uint16_t TIM_OCClear)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCCLEAR_STATE(TIM_OCClear));
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC1CE λ */
  tmpccmr1 &= CCMR_OC13CE_Reset;
  /* ʹܻʧȽλ */
  tmpccmr1 |= TIM_OCClear;
  /* д TIMx CCMR1 Ĵ */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @  һⲿ¼ʱ߱ OCREF2 ź
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCClear: Ƚʹλ״̬.
  *                     ȡֵ֮һ:
  *                     TIM_OCClear_Enable:  TIM Ƚʹ
  *                     TIM_OCClear_Disable: TIM Ƚʧ
  * @  û
  */
void TIM_ClearOC2Ref(TIM_TypeDef* TIMx, uint16_t TIM_OCClear)
{
  uint16_t tmpccmr1 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCCLEAR_STATE(TIM_OCClear));
  tmpccmr1 = TIMx->CCMR1;
  /* λ OC2CE λ */
  tmpccmr1 &= CCMR_OC24CE_Reset;
  /* ʹܻʧȽλ */
  tmpccmr1 |= (uint16_t)(TIM_OCClear << 8);
  /* д TIMx CCMR1 Ĵ */
  TIMx->CCMR1 = tmpccmr1;
}

/**
  * @  һⲿ¼ʱ߱ OCREF3 ź
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCClear: Ƚʹλ״̬.
  *                     ȡֵ֮һ:
  *                     TIM_OCClear_Enable:  TIM Ƚʹ
  *                     TIM_OCClear_Disable: TIM Ƚʧ
  * @  û
  */
void TIM_ClearOC3Ref(TIM_TypeDef* TIMx, uint16_t TIM_OCClear)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCCLEAR_STATE(TIM_OCClear));
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC3CE λ */
  tmpccmr2 &= CCMR_OC13CE_Reset;
  /* ʹܻʧȽλ */
  tmpccmr2 |= TIM_OCClear;
  /* д TIMx CCMR2 Ĵ */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @  һⲿ¼ʱ߱ OCREF4 ź
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCClear: Ƚʹλ״̬.
  *                     ȡֵ֮һ:
  *                     TIM_OCClear_Enable:  TIM Ƚʹ
  *                     TIM_OCClear_Disable: TIM Ƚʧ
  * @  û
  */
void TIM_ClearOC4Ref(TIM_TypeDef* TIMx, uint16_t TIM_OCClear)
{
  uint16_t tmpccmr2 = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OCCLEAR_STATE(TIM_OCClear));
  tmpccmr2 = TIMx->CCMR2;
  /* λ OC4CE λ */
  tmpccmr2 &= CCMR_OC24CE_Reset;
  /* ʹܻʧȽλ */
  tmpccmr2 |= (uint16_t)(TIM_OCClear << 8);
  /* д TIMx CCMR2 Ĵ */
  TIMx->CCMR2 = tmpccmr2;
}

/**
  * @   TIMx ͨ1.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPolarity: ָ OC1 
  *                        ȡֵ֮һ:
  *                        TIM_OCPolarity_High: ȽϼԸ
  *                        TIM_OCPolarity_Low:  ȽϼԵ
  * @  û
  */
void TIM_OC1PolarityConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPolarity)
{
  uint16_t tmpccer = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCPolarity));
  tmpccer = TIMx->CCER;
  /* ûλ CC1P λ */
  tmpccer &= CCER_CC1P_Reset;
  tmpccer |= TIM_OCPolarity;
  /* д TIMx CCER Ĵ */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIMx ͨ 1N .
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCNPolarity: ָ OC1N 
  *                         ȡֵ֮һ:
  *                         TIM_OCNPolarity_High: ȽϼԸ
  *                         TIM_OCNPolarity_Low:  ȽϼԵ
  * @  û
  */
void TIM_OC1NPolarityConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCNPolarity)
{
  uint16_t tmpccer = 0;
  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_TIM_OCN_POLARITY(TIM_OCNPolarity));
   
  tmpccer = TIMx->CCER;
  /* ûλ CC1NP λ */
  tmpccer &= CCER_CC1NP_Reset;
  tmpccer |= TIM_OCNPolarity;
  /* д TIMx CCER Ĵ */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIMx ͨ2.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPolarity: ָ OC2 
  *                        ȡֵ֮һ:
  *                        TIM_OCPolarity_High: ȽϼԸ
  *                        TIM_OCPolarity_Low:  ȽϼԵ
  * @  û
  */
void TIM_OC2PolarityConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPolarity)
{
  uint16_t tmpccer = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCPolarity));
  tmpccer = TIMx->CCER;
  /* ûλ CC2P λ */
  tmpccer &= CCER_CC2P_Reset;
  tmpccer |= (uint16_t)(TIM_OCPolarity << 4);
  /* д TIMx CCER Ĵ */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIMx ͨ 2N .
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCNPolarity: ָ OC2N 
  *                         ȡֵ֮һ:
  *                         TIM_OCNPolarity_High: ȽϼԸ
  *                         TIM_OCNPolarity_Low:  ȽϼԵ
  * @  û
  */
void TIM_OC2NPolarityConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCNPolarity)
{
  uint16_t tmpccer = 0;
  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_TIM_OCN_POLARITY(TIM_OCNPolarity));
  
  tmpccer = TIMx->CCER;
  /* ûλ CC2NP λ */
  tmpccer &= CCER_CC2NP_Reset;
  tmpccer |= (uint16_t)(TIM_OCNPolarity << 4);
  /* д TIMx CCER Ĵ */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIMx ͨ3.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPolarity: ָ OC3 
  *                        ȡֵ֮һ:
  *                        TIM_OCPolarity_High: ȽϼԸ
  *                        TIM_OCPolarity_Low:  ȽϼԵ
  * @  û
  */
void TIM_OC3PolarityConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPolarity)
{
  uint16_t tmpccer = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCPolarity));
  tmpccer = TIMx->CCER;
  /* ûλ CC3P λ */
  tmpccer &= CCER_CC3P_Reset;
  tmpccer |= (uint16_t)(TIM_OCPolarity << 8);
  /* д TIMx CCER Ĵ */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIMx ͨ 3N .
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCNPolarity: ָ OC3N 
  *                         ȡֵ֮һ:
  *                         TIM_OCNPolarity_High: ȽϼԸ
  *                         TIM_OCNPolarity_Low:  ȽϼԵ
  * @  û
  */
void TIM_OC3NPolarityConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCNPolarity)
{
  uint16_t tmpccer = 0;
 
  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_TIM_OCN_POLARITY(TIM_OCNPolarity));
    
  tmpccer = TIMx->CCER;
  /* ûλ CC3NP λ */
  tmpccer &= CCER_CC3NP_Reset;
  tmpccer |= (uint16_t)(TIM_OCNPolarity << 8);
  /* д TIMx CCER Ĵ */
  TIMx->CCER = tmpccer;
}

/**
  * @   TIMx ͨ4.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_OCPolarity: ָ OC4 
  *                        ȡֵ֮һ:
  *                        TIM_OCPolarity_High: ȽϼԸ
  *                        TIM_OCPolarity_Low:  ȽϼԵ
  * @  û
  */
void TIM_OC4PolarityConfig(TIM_TypeDef* TIMx, uint16_t TIM_OCPolarity)
{
  uint16_t tmpccer = 0;
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_OC_POLARITY(TIM_OCPolarity));
  tmpccer = TIMx->CCER;
  /* ûλ CC4P λ */
  tmpccer &= CCER_CC4P_Reset;
  tmpccer |= (uint16_t)(TIM_OCPolarity << 12);
  /* д TIMx CCER Ĵ */
  TIMx->CCER = tmpccer;
}

/**
  * @  ʹܻʧ TIM Ƚͨ x.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_Channel: ָ TIM ͨ
  *          ȡֵ֮һ:
  *          TIM_Channel_1: TIM ͨ 1
  *          TIM_Channel_2: TIM ͨ 2
  *          TIM_Channel_3: TIM ͨ 3
  *          TIM_Channel_4: TIM ͨ 4
  * @  TIM_CCx: ָ TIM ͨ CCxE λ״̬.
  *                 : TIM_CCx_Enable  TIM_CCx_Disable. 
  * @  û
  */
void TIM_CCxCmd(TIM_TypeDef* TIMx, uint16_t TIM_Channel, uint16_t TIM_CCx)
{
  uint16_t tmp = 0;

  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_CHANNEL(TIM_Channel));
  assert_param(IS_TIM_CCX(TIM_CCx));

  tmp = CCER_CCE_Set << TIM_Channel;

  /* λ CCxE λ */
  TIMx->CCER &= (uint16_t)~ tmp;

  /* ûλ CCxE λ */ 
  TIMx->CCER |=  (uint16_t)(TIM_CCx << TIM_Channel);
}

/**
  * @  ʹܻʧ TIM Ƚͨ xN.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_Channel: ָ TIM ͨ
  *          ȡֵ֮һ:
  *          TIM_Channel_1: TIM ͨ 1
  *          TIM_Channel_2: TIM ͨ 2
  *          TIM_Channel_3: TIM ͨ 3
  * @  TIM_CCxN: ָ TIM ͨ CCxNE λ״̬.
  *                  : TIM_CCxN_Enable  TIM_CCxN_Disable. 
  * @  û
  */
void TIM_CCxNCmd(TIM_TypeDef* TIMx, uint16_t TIM_Channel, uint16_t TIM_CCxN)
{
  uint16_t tmp = 0;

  /*  */
  assert_param(IS_TIM_18_PERIPH(TIMx));
  assert_param(IS_TIM_COMPLEMENTARY_CHANNEL(TIM_Channel));
  assert_param(IS_TIM_CCXN(TIM_CCxN));

  tmp = CCER_CCNE_Set << TIM_Channel;

  /* λ CCxNE λ */
  TIMx->CCER &= (uint16_t) ~tmp;

  /* ûλ CCxNE λ */ 
  TIMx->CCER |=  (uint16_t)(TIM_CCxN << TIM_Channel);
}

/**
  * @  ѡ TIM Ƚģʽ.
  * @ע   ڸıȽģʽ֮ǰúʧѡͨ.
  *         ûҪʹ TIM1_CCxCmd  TIM1_CCxNCmd ʹͨ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_Channel: ָ TIM ͨ
  *          ȡֵ֮һ:
  *          TIM_Channel_1: TIM ͨ 1
  *          TIM_Channel_2: TIM ͨ 2
  *          TIM_Channel_3: TIM ͨ 3
  *          TIM_Channel_4: TIM ͨ 4
  * @  TIM_OCMode: ָ TIM Ƚģʽ.
  *          ȡֵ֮һ:
  *          TIM_OCMode_Timing
  *          TIM_OCMode_Active
  *          TIM_OCMode_Toggle
  *          TIM_OCMode_PWM1
  *          TIM_OCMode_PWM2
  *          TIM_ForcedAction_Active
  *          TIM_ForcedAction_InActive
  * @  û
  */
void TIM_SelectOCxM(TIM_TypeDef* TIMx, uint16_t TIM_Channel, uint16_t TIM_OCMode)
{
  uint32_t tmp = 0;
  uint16_t tmp1 = 0;

  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_CHANNEL(TIM_Channel));
  assert_param(IS_TIM_OCM(TIM_OCMode));

  tmp = (uint32_t) TIMx;
  tmp += CCMR_Offset;

  tmp1 = CCER_CCE_Set << (uint16_t)TIM_Channel;

  /* ʧͨ: λ CCxE λ */
  TIMx->CCER &= (uint16_t) ~tmp1;

  if((TIM_Channel == TIM_Channel_1) ||(TIM_Channel == TIM_Channel_3))
  {
    tmp += (TIM_Channel>>1);

    /* λ OCxM λ CCMRx Ĵ */
    *(__IO uint32_t *) tmp &= CCMR_OC13M_Mask;
   
    /*  OCxM λ CCMRx Ĵ */
    *(__IO uint32_t *) tmp |= TIM_OCMode;
  }
  else
  {
    tmp += (uint16_t)(TIM_Channel - (uint16_t)4)>> (uint16_t)1;

    /* λ OCxM λ CCMRx Ĵ */
    *(__IO uint32_t *) tmp &= CCMR_OC24M_Mask;
    
    /*  OCxM λ CCMRx Ĵ */
    *(__IO uint32_t *) tmp |= (uint16_t)(TIM_OCMode << 8);
  }
}

/**
  * @  ʹܻʧ TIM ¼.
  * @  TIMx: ˴x18ѡ.
  * @  NewState: TIM1_CR1ĴUDISλ״̬
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_UpdateDisableConfig(TIM_TypeDef* TIMx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* øʧλ */
    TIMx->CR1 |= CR1_UDIS_Set;
  }
  else
  {
    /* λʧλ */
    TIMx->CR1 &= CR1_UDIS_Reset;
  }
}

/**
  * @   TIMx Դ.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_UpdateSource: ָԴ.
  *          ȡֵ֮һ:
  *          TIM_UpdateSource_Regular: ظ壺ڸ¼ʱֹͣ.
  *          TIM_UpdateSource_Global:  ɵһ壺һ¼ֹͣ.
  * @  û
  */
void TIM_UpdateRequestConfig(TIM_TypeDef* TIMx, uint16_t TIM_UpdateSource)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_UPDATE_SOURCE(TIM_UpdateSource));
  if (TIM_UpdateSource != TIM_UpdateSource_Global)
  {
    /*  URS λ */
    TIMx->CR1 |= CR1_URS_Set;
  }
  else
  {
    /* λ URS λ */
    TIMx->CR1 &= CR1_URS_Reset;
  }
}

/**
  * @  ʹܻʧ TIM ӿ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  NewState: Ӧ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void TIM_SelectHallSensor(TIM_TypeDef* TIMx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /*  TI1S λ */
    TIMx->CR2 |= CR2_TI1S_Set;
  }
  else
  {
    /* λ TI1S λ */
    TIMx->CR2 &= CR2_TI1S_Reset;
  }
}

/**
  * @   TIM ģʽ.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_OPMode: ָ OPM ģʽ.
  *                    ȡֵ֮һ:
  *                    TIM_OPMode_Single
  *                    TIM_OPMode_Repetitive
  * @  û
  */
void TIM_SelectOnePulseMode(TIM_TypeDef* TIMx, uint16_t TIM_OPMode)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_OPM_MODE(TIM_OPMode));
  /* λ OPM λ */
  TIMx->CR1 &= CR1_OPM_Reset;
  /*  OPM ģʽ */
  TIMx->CR1 |= TIM_OPMode;
}

/**
  * @  ѡ TIM ģʽ.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_TRGOSource: ָĴģʽ.
  *                        ֵ:
  *
  *  - е TIMx
  *          TIM_TRGOSource_Reset:  ʹüĴTIM1_EGRUGλΪ (TRGO).
  *          TIM_TRGOSource_Enable: ʹüʹCENΪ (TRGO).
  *          TIM_TRGOSource_Update: ʹø¼Ϊ (TRGO).
  *
  *  - е TIMx  TIM6  TIM7
  *          TIM_TRGOSource_OC1:    һ߱Ƚƥ䷢־λCC1Fʱһ϶ (TRGO).
  *          TIM_TRGOSource_OC1Ref: ʹ OC1REF Ϊ (TRGO).
  *          TIM_TRGOSource_OC2Ref: ʹ OC2REF Ϊ (TRGO).
  *          TIM_TRGOSource_OC3Ref: ʹ OC3REF Ϊ (TRGO).
  *          TIM_TRGOSource_OC4Ref: ʹ OC4REF Ϊ (TRGO).
  *
  * @  û
  */
void TIM_SelectOutputTrigger(TIM_TypeDef* TIMx, uint16_t TIM_TRGOSource)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_TRGO_SOURCE(TIM_TRGOSource));
  /* λ MMS λ */
  TIMx->CR2 &= CR2_MMS_Mask;
  /* ѡ TRGO Դ */
  TIMx->CR2 |=  TIM_TRGOSource;
}

/**
  * @  ѡ TIMx ģʽ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_SlaveMode: ָʱģʽ.
  *          ȡֵ֮һ:
  *          TIM_SlaveMode_Reset:     ѡдź (TRGI) سʼĴĸ.
  *          TIM_SlaveMode_Gated:     ź (TRGI) Ϊߵƽʱʹ.
  *          TIM_SlaveMode_Trigger:   ڴ (TRGI) ؿʼ.
  *          TIM_SlaveMode_External1: ѡд (TRGI) Ϊʱ.
  * @  û
  */
void TIM_SelectSlaveMode(TIM_TypeDef* TIMx, uint16_t TIM_SlaveMode)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_SLAVE_MODE(TIM_SlaveMode));
  /* λ SMS λ */
  TIMx->SMCR &= SMCR_SMS_Mask;
  /* ѡģʽ */
  TIMx->SMCR |= TIM_SlaveMode;
}

/**
  * @  ûλ TIMx /ģʽ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_MasterSlaveMode: ʱ/ģʽ.
  *          ȡֵ֮һ:
  *          TIM_MasterSlaveMode_Enable:  /ģʽʹ.
  *          TIM_MasterSlaveMode_Disable: /ģʽʧ
  * @  û
  */
void TIM_SelectMasterSlaveMode(TIM_TypeDef* TIMx, uint16_t TIM_MasterSlaveMode)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_MSM_STATE(TIM_MasterSlaveMode));
  /* λ MSM λ */
  TIMx->SMCR &= SMCR_MSM_Reset;
  
  /* ûλ MSM λ */
  TIMx->SMCR |= TIM_MasterSlaveMode;
}

/**
  * @   TIMx Ĵֵ
  * @  TIMx: ˴x18ѡ.
  * @  Counter: ָĴֵ.
  * @  û
  */
void TIM_SetCounter(TIM_TypeDef* TIMx, uint16_t Counter)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  /* üĴֵ */
  TIMx->CNT = Counter;
}

/**
  * @   TIMx ԶװؼĴֵ
  * @  TIMx: ˴x18ѡ.
  * @  Autoreload: ָԶװؼĴֵ.
  * @  û
  */
void TIM_SetAutoreload(TIM_TypeDef* TIMx, uint16_t Autoreload)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  /* ԶװؼĴֵ */
  TIMx->ARR = Autoreload;
}

/**
  * @   TIMx Ƚ1Ĵֵ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  Compare1: Ƚ1Ĵֵ.
  * @  û
  */
void TIM_SetCompare1(TIM_TypeDef* TIMx, uint16_t Compare1)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* òȽ1Ĵֵ */
  TIMx->CCR1 = Compare1;
}

/**
  * @   TIMx Ƚ2Ĵֵ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  Compare2: Ƚ2Ĵֵ.
  * @  û
  */
void TIM_SetCompare2(TIM_TypeDef* TIMx, uint16_t Compare2)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* òȽ2Ĵֵ */
  TIMx->CCR2 = Compare2;
}

/**
  * @   TIMx Ƚ3Ĵֵ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  Compare3: Ƚ3Ĵֵ.
  * @  û
  */
void TIM_SetCompare3(TIM_TypeDef* TIMx, uint16_t Compare3)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* òȽ3Ĵֵ */
  TIMx->CCR3 = Compare3;
}

/**
  * @   TIMx Ƚ4Ĵֵ
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  Compare4: Ƚ4Ĵֵ.
  * @  û
  */
void TIM_SetCompare4(TIM_TypeDef* TIMx, uint16_t Compare4)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* òȽ4Ĵֵ */
  TIMx->CCR4 = Compare4;
}

/**
  * @   TIMx 벶1ԤƵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPSC: 벶1ԤƵֵ.
  *          ȡֵ֮һ:
  *          TIM_ICPSC_DIV1: ûԤƵ
  *          TIM_ICPSC_DIV2: ÿ2¼TIMִһ
  *          TIM_ICPSC_DIV4: ÿ4¼TIMִһ
  *          TIM_ICPSC_DIV8: ÿ8¼TIMִһ
  * @  û
  */
void TIM_SetIC1Prescaler(TIM_TypeDef* TIMx, uint16_t TIM_ICPSC)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_IC_PRESCALER(TIM_ICPSC));
  /* λ IC1PSC λ */
  TIMx->CCMR1 &= CCMR_IC13PSC_Mask;
  /*  IC1PSC ֵ */
  TIMx->CCMR1 |= TIM_ICPSC;
}

/**
  * @   TIMx 벶2ԤƵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPSC: 벶2ԤƵֵ.
  *          ȡֵ֮һ:
  *          TIM_ICPSC_DIV1: ûԤƵ
  *          TIM_ICPSC_DIV2: ÿ2¼TIMִһ
  *          TIM_ICPSC_DIV4: ÿ4¼TIMִһ
  *          TIM_ICPSC_DIV8: ÿ8¼TIMִһ
  * @  û
  */
void TIM_SetIC2Prescaler(TIM_TypeDef* TIMx, uint16_t TIM_ICPSC)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_IC_PRESCALER(TIM_ICPSC));
  /* λ IC2PSC λ */
  TIMx->CCMR1 &= CCMR_IC24PSC_Mask;
  /*  IC2PSC ֵ */
  TIMx->CCMR1 |= (uint16_t)(TIM_ICPSC << 8);
}

/**
  * @   TIMx 벶3ԤƵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPSC: 벶3ԤƵֵ.
  *          ȡֵ֮һ:
  *          TIM_ICPSC_DIV1: ûԤƵ
  *          TIM_ICPSC_DIV2: ÿ2¼TIMִһ
  *          TIM_ICPSC_DIV4: ÿ4¼TIMִһ
  *          TIM_ICPSC_DIV8: ÿ8¼TIMִһ
  * @  û
  */
void TIM_SetIC3Prescaler(TIM_TypeDef* TIMx, uint16_t TIM_ICPSC)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_IC_PRESCALER(TIM_ICPSC));
  /* λ IC3PSC λ */
  TIMx->CCMR2 &= CCMR_IC13PSC_Mask;
  /*  IC3PSC ֵ */
  TIMx->CCMR2 |= TIM_ICPSC;
}

/**
  * @   TIMx 벶4ԤƵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPSC: 벶4ԤƵֵ.
  *          ȡֵ֮һ:
  *          TIM_ICPSC_DIV1: ûԤƵ
  *          TIM_ICPSC_DIV2: ÿ2¼TIMִһ
  *          TIM_ICPSC_DIV4: ÿ4¼TIMִһ
  *          TIM_ICPSC_DIV8: ÿ8¼TIMִһ
  * @  û
  */
void TIM_SetIC4Prescaler(TIM_TypeDef* TIMx, uint16_t TIM_ICPSC)
{  
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_IC_PRESCALER(TIM_ICPSC));
  /* λ IC4PSC λ */
  TIMx->CCMR2 &= CCMR_IC24PSC_Mask;
  /*  IC4PSC ֵ */
  TIMx->CCMR2 |= (uint16_t)(TIM_ICPSC << 8);
}

/**
  * @   TIMx ʱӷֵָ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_CKD: ʱӷֵָ.
  *          ȡֵ֮һ:
  *          TIM_CKD_DIV1: TDTS = Tck_tim
  *          TIM_CKD_DIV2: TDTS = 2*Tck_tim
  *          TIM_CKD_DIV4: TDTS = 4*Tck_tim
  * @  û
  */
void TIM_SetClockDivision(TIM_TypeDef* TIMx, uint16_t TIM_CKD)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  assert_param(IS_TIM_CKD_DIV(TIM_CKD));
  /* λ CKD λ */
  TIMx->CR1 &= CR1_CKD_Mask;
  /*  CKD ֵ */
  TIMx->CR1 |= TIM_CKD;
}

/**
  * @   TIMx 벶1ֵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  벶1ֵ.
  */
uint16_t TIM_GetCapture1(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* 벶1ֵ */
  return TIMx->CCR1;
}

/**
  * @   TIMx 벶2ֵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  벶2ֵ.
  */
uint16_t TIM_GetCapture2(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* 벶2ֵ */
  return TIMx->CCR2;
}

/**
  * @   TIMx 벶3ֵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  벶3ֵ.
  */
uint16_t TIM_GetCapture3(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx)); 
  /* 벶3ֵ */
  return TIMx->CCR3;
}

/**
  * @   TIMx 벶4ֵ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  벶4ֵ.
  */
uint16_t TIM_GetCapture4(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_123458_PERIPH(TIMx));
  /* 벶4ֵ */
  return TIMx->CCR4;
}

/**
  * @   TIMx ֵ.
  * @  TIMx: ˴x18ѡ.
  * @  ֵ.
  */
uint16_t TIM_GetCounter(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  /* üֵ */
  return TIMx->CNT;
}

/**
  * @   TIMx ԤƵֵ.
  * @  TIMx: ˴x18ѡ.
  * @  ԤƵֵ.
  */
uint16_t TIM_GetPrescaler(TIM_TypeDef* TIMx)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  /* ԤƵֵ */
  return TIMx->PSC;
}

/**
  * @  ָ TIM ־λ.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_FLAG:  TIM ־λ.
  *          ȡֵ֮һ:
  *          TIM_FLAG_Update: TIM ±־
  *          TIM_FLAG_CC1: TIM /Ƚ 1 ־λ
  *          TIM_FLAG_CC2: TIM /Ƚ 2 ־λ
  *          TIM_FLAG_CC3: TIM /Ƚ 3 ־λ
  *          TIM_FLAG_CC4: TIM /Ƚ 4 ־λ
  *          TIM_FLAG_COM: TIM Com־
  *          TIM_FLAG_Trigger: TIM ־λ
  *          TIM_FLAG_Break: TIM Ϣ־
  *          TIM_FLAG_CC1OF: TIM /Ƚ 1 ־λ
  *          TIM_FLAG_CC2OF: TIM /Ƚ 2 ־λ
  *          TIM_FLAG_CC3OF: TIM /Ƚ 3 ־λ
  *          TIM_FLAG_CC4OF: TIM /Ƚ 4 ־λ
  * @ע
  *   - TIM6  TIM7 һж. 
  *   - TIM_FLAG_COM  TIM_FLAG_Break Ժ TIM1  TIM8 һʹ.    
  * @  TIM_FLAG ״̬(SET  RESET).
  */
FlagStatus TIM_GetFlagStatus(TIM_TypeDef* TIMx, uint16_t TIM_FLAG)
{ 
  ITStatus bitstatus = RESET;  
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_GET_FLAG(TIM_FLAG));
  
  if ((TIMx->SR & TIM_FLAG) != (uint16_t)RESET)
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  return bitstatus;
}

/**
  * @   TIMx Ĵ־λ.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_FLAG: ı.
  *          ֵ:
  *          TIM_FLAG_Update: TIM ±־
  *          TIM_FLAG_CC1: TIM /Ƚ 1 ־λ
  *          TIM_FLAG_CC2: TIM /Ƚ 2 ־λ
  *          TIM_FLAG_CC3: TIM /Ƚ 3 ־λ
  *          TIM_FLAG_CC4: TIM /Ƚ 4 ־λ
  *          TIM_FLAG_COM: TIM Com־
  *          TIM_FLAG_Trigger: TIM ־λ
  *          TIM_FLAG_Break: TIM жϱ־
  *          TIM_FLAG_CC1OF: TIM /Ƚ 1 ־λ
  *          TIM_FLAG_CC2OF: TIM /Ƚ 2 ־λ
  *          TIM_FLAG_CC3OF: TIM /Ƚ 3 ־λ
  *          TIM_FLAG_CC4OF: TIM /Ƚ 4 ־λ
  * @ע
  *   - TIM6  TIM7 һж. 
  *   - TIM_FLAG_COM  TIM_FLAG_Break Ժ TIM1  TIM8 һʹ.    
  * @  û.
  */
void TIM_ClearFlag(TIM_TypeDef* TIMx, uint16_t TIM_FLAG)
{  
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_CLEAR_FLAG(TIM_FLAG));
   
  /* ־λ */
  TIMx->SR = (uint16_t)~TIM_FLAG;
}

/**
  * @  ָ TIM жϷ.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_IT:  TIM жԴ.
  *          ȡֵ֮һ:
  *          TIM_IT_Update: TIM жԴ
  *          TIM_IT_CC1: TIM /Ƚ 1 жԴ
  *          TIM_IT_CC2: TIM /Ƚ 2 жԴ
  *          TIM_IT_CC3: TIM /Ƚ 3 жԴ
  *          TIM_IT_CC4: TIM /Ƚ 4 жԴ
  *          TIM_IT_COM: TIM Com жԴ
  *          TIM_IT_Trigger: TIM жԴ
  *          TIM_IT_Break: TIM ϢжԴ
  * @ע
  *   - TIM6  TIM7 һж. 
  *   - TIM_FLAG_COM  TIM_FLAG_Break Ժ TIM1  TIM8 һʹ.   
  * @  TIM_IT ״̬(SET  RESET).
  */
ITStatus TIM_GetITStatus(TIM_TypeDef* TIMx, uint16_t TIM_IT)
{
  ITStatus bitstatus = RESET;  
  uint16_t itstatus = 0x0, itenable = 0x0;
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_GET_IT(TIM_IT));
   
  itstatus = TIMx->SR & TIM_IT;
  
  itenable = TIMx->DIER & TIM_IT;
  if ((itstatus != (uint16_t)RESET) && (itenable != (uint16_t)RESET))
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  return bitstatus;
}

/**
  * @   TIMx жϴλ.
  * @  TIMx: ˴x18ѡ.
  * @  TIM_IT: ָжϴλ.
  *          ֵ:
  *          TIM_IT_Update: TIM жԴ
  *          TIM_IT_CC1: TIM /Ƚ 1 жԴ
  *          TIM_IT_CC2: TIM /Ƚ 2 жԴ
  *          TIM_IT_CC3: TIM /Ƚ 3 жԴ
  *          TIM_IT_CC4: TIM /Ƚ 4 жԴ
  *          TIM_IT_COM: TIM Com жԴ
  *          TIM_IT_Trigger: TIM жԴ
  *          TIM_IT_Break: TIM ϢжԴ
  * @ע
  *   - TIM6  TIM7 һж. 
  *   - TIM_FLAG_COM  TIM_FLAG_Break Ժ TIM1  TIM8 һʹ.  
  * @  û
  */
void TIM_ClearITPendingBit(TIM_TypeDef* TIMx, uint16_t TIM_IT)
{
  /*  */
  assert_param(IS_TIM_ALL_PERIPH(TIMx));
  assert_param(IS_TIM_IT(TIM_IT));
  /*  TIMx жϴλ */
  TIMx->SR = (uint16_t)~TIM_IT;
}

/**
  * @   TI1 Ϊ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPolarity : 뼫.
  *          ȡֵ֮һ:
  *          TIM_ICPolarity_Rising
  *          TIM_ICPolarity_Falling
  * @  TIM_ICSelection: ʹָ.
  *          ȡֵ֮һ:
  *          TIM_ICSelection_DirectTI:   ѡTIM 1IC1.
  *          TIM_ICSelection_IndirectTI: ѡTIM 1IC2.
  *          TIM_ICSelection_TRC:        ѡTIM 1TRC.
  * @  TIM_ICFilter: ָ벶˲.
  *                      ֵ 0x00  0x0F֮.
  * @  û
  */
static void TI1_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter)
{
  uint16_t tmpccmr1 = 0, tmpccer = 0;
  /* ʧͨ 1: λ CC1E λ */
  TIMx->CCER &= CCER_CC1E_Reset;
  tmpccmr1 = TIMx->CCMR1;
  tmpccer = TIMx->CCER;
  /* ѡ˲ */
  tmpccmr1 &= CCMR_CC13S_Mask & CCMR_IC13F_Mask;
  tmpccmr1 |= (uint16_t)(TIM_ICSelection | (uint16_t)(TIM_ICFilter << (uint16_t)4));
  /* ѡԺλCC1E */
  tmpccer &= CCER_CC1P_Reset;
  tmpccer |= (uint16_t)(TIM_ICPolarity | (uint16_t)CCER_CC1E_Set);
  /* дTIMx CCMR1CCERĴ */
  TIMx->CCMR1 = tmpccmr1;
  TIMx->CCER = tmpccer;
}

/**
  * @   TI2 Ϊ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPolarity : 뼫.
  *          ȡֵ֮һ:
  *          TIM_ICPolarity_Rising
  *          TIM_ICPolarity_Falling
  * @  TIM_ICSelection: ʹָ.
  *          ȡֵ֮һ:
  *          TIM_ICSelection_DirectTI:   ѡTIM 2IC2.
  *          TIM_ICSelection_IndirectTI: ѡTIM 2IC1.
  *          TIM_ICSelection_TRC:        ѡTIM 2TRC.
  * @  TIM_ICFilter: ָ벶˲.
  *                      ֵ 0x00  0x0F֮.
  * @  û
  */
static void TI2_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter)
{
  uint16_t tmpccmr1 = 0, tmpccer = 0, tmp = 0;
  /* ʧͨ 2: λ CC2E λ */
  TIMx->CCER &= CCER_CC2E_Reset;
  tmpccmr1 = TIMx->CCMR1;
  tmpccer = TIMx->CCER;
  tmp = (uint16_t)(TIM_ICPolarity << 4);
  /* ѡ˲ */
  tmpccmr1 &= CCMR_CC24S_Mask & CCMR_IC24F_Mask;
  tmpccmr1 |= (uint16_t)(TIM_ICFilter << 12);
  tmpccmr1 |= (uint16_t)(TIM_ICSelection << 8);
  /* ѡԺλCC2E */
  tmpccer &= CCER_CC2P_Reset;
  tmpccer |=  (uint16_t)(tmp | (uint16_t)CCER_CC2E_Set);
  /* дTIMx CCMR1CCERĴ */
  TIMx->CCMR1 = tmpccmr1 ;
  TIMx->CCER = tmpccer;
}

/**
  * @   TI3 Ϊ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPolarity : 뼫.
  *          ȡֵ֮һ:
  *          TIM_ICPolarity_Rising
  *          TIM_ICPolarity_Falling
  * @  TIM_ICSelection: ʹָ.
  *          ȡֵ֮һ:
  *          TIM_ICSelection_DirectTI:   ѡTIM 3IC3.
  *          TIM_ICSelection_IndirectTI: ѡTIM 3IC4.
  *          TIM_ICSelection_TRC:        ѡTIM 3TRC.
  * @  TIM_ICFilter: ָ벶˲.
  *                      ֵ 0x00  0x0F֮.
  * @  û
  */
static void TI3_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter)
{
  uint16_t tmpccmr2 = 0, tmpccer = 0, tmp = 0;
  /* ʧͨ 3: λ CC3E λ */
  TIMx->CCER &= CCER_CC3E_Reset;
  tmpccmr2 = TIMx->CCMR2;
  tmpccer = TIMx->CCER;
  tmp = (uint16_t)(TIM_ICPolarity << 8);
  /* ѡ˲ */
  tmpccmr2 &= CCMR_CC13S_Mask & CCMR_IC13F_Mask;
  tmpccmr2 |= (uint16_t)(TIM_ICSelection | (uint16_t)(TIM_ICFilter << (uint16_t)4));
  /* ѡԺλCC3E */
  tmpccer &= CCER_CC3P_Reset;
  tmpccer |= (uint16_t)(tmp | (uint16_t)CCER_CC3E_Set);
  /* дTIMx CCMR2CCERĴ */
  TIMx->CCMR2 = tmpccmr2;
  TIMx->CCER = tmpccer;
}

/**
  * @   TI4 Ϊ.
  * @  TIMx: ˴x1,2,3,4,58ѡ.
  * @  TIM_ICPolarity : 뼫.
  *          ȡֵ֮һ:
  *          TIM_ICPolarity_Rising
  *          TIM_ICPolarity_Falling
  * @  TIM_ICSelection: ʹָ.
  *          ȡֵ֮һ:
  *          TIM_ICSelection_DirectTI:   ѡTIM 3IC4.
  *          TIM_ICSelection_IndirectTI: ѡTIM 3IC3.
  *          TIM_ICSelection_TRC:        ѡTIM 3TRC.
  * @  TIM_ICFilter: ָ벶˲.
  *                      ֵ 0x00  0x0F֮.
  * @  û
  */
static void TI4_Config(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection,
                       uint16_t TIM_ICFilter)
{
  uint16_t tmpccmr2 = 0, tmpccer = 0, tmp = 0;

  /* ʧͨ 4: λ CC4E λ */
  TIMx->CCER &= CCER_CC4E_Reset;
  tmpccmr2 = TIMx->CCMR2;
  tmpccer = TIMx->CCER;
  tmp = (uint16_t)(TIM_ICPolarity << 12);

  /* ѡù */
  tmpccmr2 &= CCMR_CC24S_Mask & CCMR_IC24F_Mask;
  tmpccmr2 |= (uint16_t)(TIM_ICSelection << 8);
  tmpccmr2 |= (uint16_t)(TIM_ICFilter << 12);

  /* ѡԺλCC4E */
  tmpccer &= CCER_CC4P_Reset;
  tmpccer |= (uint16_t)(tmp | (uint16_t)CCER_CC4E_Set);
  /* дTIMx CCMR2CCERĴ */
  TIMx->CCMR2 = tmpccmr2;
  TIMx->CCER = tmpccer ;
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
