/**
  ******************************************************************************
  * @ļ    stm32f10x_usart.c
  * @    MCD Ӧó
  * @汾    V3.1.0
  * @    06/19/2009
  * @    ļ ṩ USART ̼.
  * @    ANSON/sweet1985 Email:airanson110@126.com
  * @    14/07/2009
  ******************************************************************************
  * @
  *
  * ̼ṩͻΪƲƷдĲοĿʹͻԼʱ䡣
  * ͻʹñ̼ڿƷϲĽⷨ뵼幫˾еκֱӵĺͼ
  * ΣҲеκ𺦶⳥
  *
  * <h2><center>&; Ȩ 2009 ⷨ뵼幫˾</center></h2>
  * 汾ѧϰӢԭгӦӢԭΪ׼
  */ 

/*  ------------------------------------------------------------------*/
#include "stm32f10x_usart.h"
#include "stm32f10x_rcc.h"

/*  --------------------------------------------------------------*/
/* ö --------------------------------------------------------------*/

#define CR1_UE_Set                ((uint16_t)0x2000)  /*!< USART Enable Mask */
#define CR1_UE_Reset              ((uint16_t)0xDFFF)  /*!< USART Disable Mask */

#define CR1_WAKE_Mask             ((uint16_t)0xF7FF)  /*!< USART WakeUp Method Mask */

#define CR1_RWU_Set               ((uint16_t)0x0002)  /*!< USART mute mode Enable Mask */
#define CR1_RWU_Reset             ((uint16_t)0xFFFD)  /*!< USART mute mode Enable Mask */
#define CR1_SBK_Set               ((uint16_t)0x0001)  /*!< USART Break Character send Mask */
#define CR1_CLEAR_Mask            ((uint16_t)0xE9F3)  /*!< USART CR1 Mask */
#define CR2_Address_Mask          ((uint16_t)0xFFF0)  /*!< USART address Mask */

#define CR2_LINEN_Set              ((uint16_t)0x4000)  /*!< USART LIN Enable Mask */
#define CR2_LINEN_Reset            ((uint16_t)0xBFFF)  /*!< USART LIN Disable Mask */

#define CR2_LBDL_Mask             ((uint16_t)0xFFDF)  /*!< USART LIN Break detection Mask */
#define CR2_STOP_CLEAR_Mask       ((uint16_t)0xCFFF)  /*!< USART CR2 STOP Bits Mask */
#define CR2_CLOCK_CLEAR_Mask      ((uint16_t)0xF0FF)  /*!< USART CR2 Clock Mask */

#define CR3_SCEN_Set              ((uint16_t)0x0020)  /*!< USART SC Enable Mask */
#define CR3_SCEN_Reset            ((uint16_t)0xFFDF)  /*!< USART SC Disable Mask */

#define CR3_NACK_Set              ((uint16_t)0x0010)  /*!< USART SC NACK Enable Mask */
#define CR3_NACK_Reset            ((uint16_t)0xFFEF)  /*!< USART SC NACK Disable Mask */

#define CR3_HDSEL_Set             ((uint16_t)0x0008)  /*!< USART Half-Duplex Enable Mask */
#define CR3_HDSEL_Reset           ((uint16_t)0xFFF7)  /*!< USART Half-Duplex Disable Mask */

#define CR3_IRLP_Mask             ((uint16_t)0xFFFB)  /*!< USART IrDA LowPower mode Mask */
#define CR3_CLEAR_Mask            ((uint16_t)0xFCFF)  /*!< USART CR3 Mask */

#define CR3_IREN_Set              ((uint16_t)0x0002)  /*!< USART IrDA Enable Mask */
#define CR3_IREN_Reset            ((uint16_t)0xFFFD)  /*!< USART IrDA Disable Mask */
#define GTPR_LSB_Mask             ((uint16_t)0x00FF)  /*!< Guard Time Register LSB Mask */
#define GTPR_MSB_Mask             ((uint16_t)0xFF00)  /*!< Guard Time Register MSB Mask */
#define IT_Mask                   ((uint16_t)0x001F)  /*!< USART Interrupt Mask */

/* ú -------------------------------------------------------------*/
/* ñ -----------------------------------------------------------*/
/* úԭ -------------------------------------------------------*/
/* ú -----------------------------------------------------------*/

/**
  * @   USARTx ĴΪȱʡֵ.
  * @  USARTx: ѡ USART Χ豸. 
  *                ȡֵ֮һ: USART1, USART2, USART3, UART4  UART5.
  * @  û
  */
void USART_DeInit(USART_TypeDef* USARTx)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));

  if (USARTx == USART1)
  {
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_USART1, ENABLE);
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_USART1, DISABLE);
  }
  else if (USARTx == USART2)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART2, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART2, DISABLE);
  }
  else if (USARTx == USART3)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART3, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_USART3, DISABLE);
  }    
  else if (USARTx == UART4)
  {
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART4, ENABLE);
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART4, DISABLE);
  }    
  else
  {
    if (USARTx == UART5)
    { 
      RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART5, ENABLE);
      RCC_APB1PeriphResetCmd(RCC_APB1Periph_UART5, DISABLE);
    }
  }
}

/**
  * @   USART_InitStruct ָĲʼ USARTx Ĵ.
  * @  USARTx: ѡ USART Χ豸. 
  *                ȡֵ֮һ: USART1, USART2, USART3, UART4  UART5.
  * @  USART_InitStruct: ָṹ USART_InitTypeDef ָ룬 USART Ϣ.
  * @  û
  */
void USART_Init(USART_TypeDef* USARTx, USART_InitTypeDef* USART_InitStruct)
{
  uint32_t tmpreg = 0x00, apbclock = 0x00;
  uint32_t integerdivider = 0x00;
  uint32_t fractionaldivider = 0x00;
  uint32_t usartxbase = 0;
  RCC_ClocksTypeDef RCC_ClocksStatus;
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_BAUDRATE(USART_InitStruct->USART_BaudRate));  
  assert_param(IS_USART_WORD_LENGTH(USART_InitStruct->USART_WordLength));
  assert_param(IS_USART_STOPBITS(USART_InitStruct->USART_StopBits));
  assert_param(IS_USART_PARITY(USART_InitStruct->USART_Parity));
  assert_param(IS_USART_MODE(USART_InitStruct->USART_Mode));
  assert_param(IS_USART_HARDWARE_FLOW_CONTROL(USART_InitStruct->USART_HardwareFlowControl));
  /* The hardware flow control is available only for USART1, USART2 and USART3 */
  if (USART_InitStruct->USART_HardwareFlowControl != USART_HardwareFlowControl_None)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  }

  usartxbase = (uint32_t)USARTx;

/*---------------------------- USART CR2 Configuration -----------------------*/
  tmpreg = USARTx->CR2;
  /*  STOP[13:12] λ */
  tmpreg &= CR2_STOP_CLEAR_Mask;
  /*  USART λ, ʱ, ʱӼ, ʱλ  ĩλ ------------*/
  /*  STOP[13:12] λ USART_StopBits ֵ */
  tmpreg |= (uint32_t)USART_InitStruct->USART_StopBits;
  
  /* д USART CR2 */
  USARTx->CR2 = (uint16_t)tmpreg;

/*---------------------------- USART CR1 Configuration -----------------------*/
  tmpreg = USARTx->CR1;
  /*  M, PCE, PS, TE  RE λ */
  tmpreg &= CR1_CLEAR_Mask;
  /*  USART ֳ, ż  ģʽ ----------------------- */
  /*  M   λ USART_WordLength ֵ */
  /*  PCE  PS λ USART_Parity ֵ */
  /*  TE   RE λ USART_Mode ֵ */
  tmpreg |= (uint32_t)USART_InitStruct->USART_WordLength | USART_InitStruct->USART_Parity |
            USART_InitStruct->USART_Mode;
  /* д USART CR1 */
  USARTx->CR1 = (uint16_t)tmpreg;

/*---------------------------- USART CR3 Configuration -----------------------*/  
  tmpreg = USARTx->CR3;
  /*  CTSE  RTSE λ */
  tmpreg &= CR3_CLEAR_Mask;
  /*  USART HFC -------------------------------------------------*/
  /*  CTSE  RTSE λ USART_HardwareFlowControl ֵ */
  tmpreg |= USART_InitStruct->USART_HardwareFlowControl;
  /* д USART CR3 */
  USARTx->CR3 = (uint16_t)tmpreg;

/*---------------------------- USART BRR Configuration -----------------------*/
  /*  USART  -------------------------------------------*/
  RCC_GetClocksFreq(&RCC_ClocksStatus);
  if (usartxbase == USART1_BASE)
  {
    apbclock = RCC_ClocksStatus.PCLK2_Frequency;
  }
  else
  {
    apbclock = RCC_ClocksStatus.PCLK1_Frequency;
  }
  /* ȷ */
  integerdivider = ((0x19 * apbclock) / (0x04 * (USART_InitStruct->USART_BaudRate)));
  tmpreg = (integerdivider / 0x64) << 0x04;
  /* ȷ */
  fractionaldivider = integerdivider - (0x64 * (tmpreg >> 0x04));
  tmpreg |= ((((fractionaldivider * 0x10) + 0x32) / 0x64)) & ((uint8_t)0x0F);
  /* д USART BRR */
  USARTx->BRR = (uint16_t)tmpreg;
}

/**
  * @   USART_InitStruct еÿһȱʡֵ.
  * @  USART_InitStruct: ָṹ USART_InitTypeDef ָ룬ʼ.
  * @  û
  */
void USART_StructInit(USART_InitTypeDef* USART_InitStruct)
{
  /* USART_InitStruct ṹȱʡֵ */
  USART_InitStruct->USART_BaudRate = 9600;
  USART_InitStruct->USART_WordLength = USART_WordLength_8b;
  USART_InitStruct->USART_StopBits = USART_StopBits_1;
  USART_InitStruct->USART_Parity = USART_Parity_No ;
  USART_InitStruct->USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_InitStruct->USART_HardwareFlowControl = USART_HardwareFlowControl_None;  
}

/**
  * @  ʼ USARTx Χʱӣ USART_ClockInitStruct ڵĲ.
  * @  USARTx: xȡ 1, 2, 3 ѡ USART Χ豸.
  * @  USART_ClockInitStruct: ָ USART_ClockInitTypeDef ָ룬 USART Ϣ.  
  * @ע  ܿģʽӦ UART4  UART5.
  * @  û
  */
void USART_ClockInit(USART_TypeDef* USARTx, USART_ClockInitTypeDef* USART_ClockInitStruct)
{
  uint32_t tmpreg = 0x00;
  /*  */
  assert_param(IS_USART_123_PERIPH(USARTx));
  assert_param(IS_USART_CLOCK(USART_ClockInitStruct->USART_Clock));
  assert_param(IS_USART_CPOL(USART_ClockInitStruct->USART_CPOL));
  assert_param(IS_USART_CPHA(USART_ClockInitStruct->USART_CPHA));
  assert_param(IS_USART_LASTBIT(USART_ClockInitStruct->USART_LastBit));
  
/*---------------------------- USART CR2 Configuration -----------------------*/
  tmpreg = USARTx->CR2;
  /*  CLKEN, CPOL, CPHA  LBCL λ */
  tmpreg &= CR2_CLOCK_CLEAR_Mask;
  /*  USART Clock, CPOL, CPHA and LastBit ------------*/
  /*  CLKEN λ USART_Clock ֵ */
  /*  CPOL  λ USART_CPOL ֵ */
  /*  CPHA  λ USART_CPHA ֵ */
  /*  LBCL  λ USART_LastBit ֵ */
  tmpreg |= (uint32_t)USART_ClockInitStruct->USART_Clock | USART_ClockInitStruct->USART_CPOL | 
                 USART_ClockInitStruct->USART_CPHA | USART_ClockInitStruct->USART_LastBit;
  /* д USART CR2 */
  USARTx->CR2 = (uint16_t)tmpreg;
}

/**
  * @  Ĭֵÿһ USART_ClockInitStruct ĳԱ.
  * @  USART_ClockInitStruct: ָ USART_ClockInitTypeDef ṹָ룬ڳʼ.
  * @  û
  */
void USART_ClockStructInit(USART_ClockInitTypeDef* USART_ClockInitStruct)
{
  /* USART_ClockInitStruct ṹȱʡֵ */
  USART_ClockInitStruct->USART_Clock = USART_Clock_Disable;
  USART_ClockInitStruct->USART_CPOL = USART_CPOL_Low;
  USART_ClockInitStruct->USART_CPHA = USART_CPHA_1Edge;
  USART_ClockInitStruct->USART_LastBit = USART_LastBit_Disable;
}

/**
  * @  ʹܻʧ USART .
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4  UART5.
  * @  NewState: USARTx Χ豸״̬.
  *                  : ENABLE or DISABLE.
  * @  û
  */
void USART_Cmd(USART_TypeDef* USARTx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  
  if (NewState != DISABLE)
  {
    /* Enable the selected USART by setting the UE bit in the CR1 register */
    USARTx->CR1 |= CR1_UE_Set;
  }
  else
  {
    /* Disable the selected USART by clearing the UE bit in the CR1 register */
    USARTx->CR1 &= CR1_UE_Reset;
  }
}

/**
  * @  ʹܻʧָ USART ж.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_IT: ָҪʹܻʧܵ USART жԴ.
  *          ֵ֮һ :
  *          USART_IT_CTS:  CTS ıж (Ӧ UART4  UART5)
  *          USART_IT_LBD:  LIN ж
  *          USART_IT_TXE:  ݼĴж
  *          USART_IT_TC:   ж
  *          USART_IT_RXNE: ݼĴΪж
  *          USART_IT_IDLE: ж
  *          USART_IT_PE:   żж
  *          USART_IT_ERR:  ж(, , )
  * @  NewState: ָ USARTx жϵ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void USART_ITConfig(USART_TypeDef* USARTx, uint16_t USART_IT, FunctionalState NewState)
{
  uint32_t usartreg = 0x00, itpos = 0x00, itmask = 0x00;
  uint32_t usartxbase = 0x00;
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_CONFIG_IT(USART_IT));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  /* CTS жϲӦ UART4  UART5 */
  if (USART_IT == USART_IT_CTS)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  }   
  
  usartxbase = (uint32_t)USARTx;

  /* õ USART Ĵַ */
  usartreg = (((uint8_t)USART_IT) >> 0x05);

  /* õжλ */
  itpos = USART_IT & IT_Mask;
  itmask = (((uint32_t)0x01) << itpos);
    
  if (usartreg == 0x01) /* The IT is in CR1 register */
  {
    usartxbase += 0x0C;
  }
  else if (usartreg == 0x02) /* The IT is in CR2 register */
  {
    usartxbase += 0x10;
  }
  else /* The IT is in CR3 register */
  {
    usartxbase += 0x14; 
  }
  if (NewState != DISABLE)
  {
    *(__IO uint32_t*)usartxbase  |= itmask;
  }
  else
  {
    *(__IO uint32_t*)usartxbase &= ~itmask;
  }
}

/**
  * @  ʹܻʧָ USART  DMA .
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3 or UART4.  
  * @  USART_DMAReq:ָ DMA .
  *          ֵ:
  *          USART_DMAReq_Tx: USART DMA 
  *          USART_DMAReq_Rx: USART DMA 
  * @  NewState: DMA Դ״̬.
  *                  : ENABLE  DISABLE.
  * @ע  DMA ģʽӦ UART5.  
  * @  û
  */
void USART_DMACmd(USART_TypeDef* USARTx, uint16_t USART_DMAReq, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_1234_PERIPH(USARTx));
  assert_param(IS_USART_DMAREQ(USART_DMAReq));  
  assert_param(IS_FUNCTIONAL_STATE(NewState)); 
  if (NewState != DISABLE)
  {
    /* ͨUSART CR3 ĴDMATDMATλ,ʹѡDMA */
    USARTx->CR3 |= USART_DMAReq;
  }
  else
  {
    /* ͨUSART CR3 ĴDMATDMATλ,ʧѡDMA */
    USARTx->CR3 &= (uint16_t)~USART_DMAReq;
  }
}

/**
  * @   USART ڵĵַ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_Address:  USART ڵĵַ.
  * @  û
  */ 
void USART_SetAddress(USART_TypeDef* USARTx, uint8_t USART_Address)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_ADDRESS(USART_Address)); 
    
  /*  USART ַ */
  USARTx->CR2 &= CR2_Address_Mask;
  /*  USART ڵĵַ */
  USARTx->CR2 |= USART_Address;
}

/**
  * @  ѡ USART Ļѷʽ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_WakeUp: ָ USART Ļѷʽ.
  *          ֵ֮һ :
  *          USART_WakeUp_IdleLine:    ߻
  *          USART_WakeUp_AddressMark: ַǻ
  * @  û
  */
void USART_WakeUpConfig(USART_TypeDef* USARTx, uint16_t USART_WakeUp)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_WAKEUP(USART_WakeUp));
  
  USARTx->CR1 &= CR1_WAKE_Mask;
  USARTx->CR1 |= USART_WakeUp;
}

/**
  * @   USART ǷھĬģʽ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  NewState: USART Ĭģʽ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void USART_ReceiverWakeUpCmd(USART_TypeDef* USARTx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_FUNCTIONAL_STATE(NewState)); 
  
  if (NewState != DISABLE)
  {
    /* ͨλCR1ĴRWUλʹUSARTģʽ */
    USARTx->CR1 |= CR1_RWU_Set;
  }
  else
  {
    /* ͨCR1ĴRWUλʧUSARTģʽ */
    USARTx->CR1 &= CR1_RWU_Reset;
  }
}

/**
  * @   USART LIN жϼⳤ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4  UART5.
  * @  USART_LINBreakDetectLength: LIN жϼⳤ.
  *          ֵ֮һ :
  *          USART_LINBreakDetectLength_10b: 10λϼ
  *          USART_LINBreakDetectLength_11b: 11λϼ
  * @  û
  */
void USART_LINBreakDetectLengthConfig(USART_TypeDef* USARTx, uint16_t USART_LINBreakDetectLength)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_LIN_BREAK_DETECT_LENGTH(USART_LINBreakDetectLength));
  
  USARTx->CR2 &= CR2_LBDL_Mask;
  USARTx->CR2 |= USART_LINBreakDetectLength;  
}

/**
  * @  ʹܻʧ USARTx  LIN ģʽ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  NewState: USART LIN ģʽ״̬.
  *                  : ENABLE or DISABLE.
  * @  û
  */
void USART_LINCmd(USART_TypeDef* USARTx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  
  if (NewState != DISABLE)
  {
    /* ͨλCR2ĴLINENλʹLINģʽ */
    USARTx->CR2 |= CR2_LINEN_Set;
  }
  else
  {
    /* ͨCR2ĴLINENλʧLINģʽ */
    USARTx->CR2 &= CR2_LINEN_Reset;
  }
}

/**
  * @  ͨ USARTx ͵.
  * @  USARTx: ѡ USART  UART Χ豸.
  *                ֵ֮һ : USART1, USART2, USART3, UART4  UART5.
  * @  Data: Ҫ͵.
  * @  û
  */
void USART_SendData(USART_TypeDef* USARTx, uint16_t Data)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_DATA(Data)); 
    
  /*  */
  USARTx->DR = (Data & (uint16_t)0x01FF);
}

/**
  * @   USARTx յ.
  * @  USARTx: ѡ USART  UART Χ豸.
  *                ֵ֮һ : USART1, USART2, USART3, UART4  UART5.
  * @  .
  */
uint16_t USART_ReceiveData(USART_TypeDef* USARTx)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  
  /*  */
  return (uint16_t)(USARTx->DR & (uint16_t)0x01FF);
}

/**
  * @  ж.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4  UART5.
  * @  û
  */
void USART_SendBreak(USART_TypeDef* USARTx)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  
  /* ж */
  USARTx->CR1 |= CR1_SBK_Set;
}

/**
  * @  ָ USART ʱ.
  * @  USARTx: xΪ1,23ѡUSARTΧ豸.
  * @  USART_GuardTime: ָıʱ.
  * @ע  ʱλӦ UART4  UART5.   
  * @  û
  */
void USART_SetGuardTime(USART_TypeDef* USARTx, uint8_t USART_GuardTime)
{    
  /*  */
  assert_param(IS_USART_123_PERIPH(USARTx));
  
  /*  USART ʱ */
  USARTx->GTPR &= GTPR_LSB_Mask;
  /*  USART ʱ */
  USARTx->GTPR |= (uint16_t)((uint16_t)USART_GuardTime << 0x08);
}

/**
  * @   USART ʱԤƵ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_Prescaler: ָԤƵ.  
  * @ע   UART4  UART5  IrDA ģʽ.
  * @  û
  */
void USART_SetPrescaler(USART_TypeDef* USARTx, uint8_t USART_Prescaler)
{ 
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  
  /*  USART ԤƵ */
  USARTx->GTPR &= GTPR_MSB_Mask;
  /*  USART ԤƵ */
  USARTx->GTPR |= USART_Prescaler;
}

/**
  * @  ʹܻʧָ USART ܿģʽ.
  * @  USARTx: xΪ1,23ѡUSARTΧ豸.
  * @  NewState: USART ܿģʽ״̬.
  *                  : ENABLE  DISABLE.     
  * @ע  ܿģʽӦ UART4  UART5 . 
  * @  û
  */
void USART_SmartCardCmd(USART_TypeDef* USARTx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_123_PERIPH(USARTx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ͨλCR3ĴSCENλʹSCģʽ */
    USARTx->CR3 |= CR3_SCEN_Set;
  }
  else
  {
    /* ͨCR3ĴSCENλʧSCģʽ */
    USARTx->CR3 &= CR3_SCEN_Reset;
  }
}

/**
  * @  ʹܻʧ NACK .
  * @  USARTx: xΪ1,23ѡUSARTΧ豸. 
  * @  NewState: NACK ״̬.
  *                  : ENABLE  DISABLE.  
  * @ע  ܿģʽӦ UART4  UART5 .
  * @  û
  */
void USART_SmartCardNACKCmd(USART_TypeDef* USARTx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_123_PERIPH(USARTx));  
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  if (NewState != DISABLE)
  {
    /* ͨλCR3ĴNACKλʹNACK */
    USARTx->CR3 |= CR3_NACK_Set;
  }
  else
  {
    /* ͨCR3ĴNACKλʧNACK */
    USARTx->CR3 &= CR3_NACK_Reset;
  }
}

/**
  * @  ʹܻʧ USART ˫ģʽ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  NewState: USART ˫ģʽ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void USART_HalfDuplexCmd(USART_TypeDef* USARTx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
  
  if (NewState != DISABLE)
  {
    /* ͨλCR3ĴHDSELλʹHalf-Duplexģʽ */
    USARTx->CR3 |= CR3_HDSEL_Set;
  }
  else
  {
    /* ͨCR3ĴHDSELλʧHalf-Duplexģʽ */
    USARTx->CR3 &= CR3_HDSEL_Reset;
  }
}

/**
  * @   USART IrDA ģʽ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4  UART5.
  * @  USART_IrDAMode: ָ IrDA ģʽ.
  *                        ֵ֮һ :
  *                        USART_IrDAMode_LowPower: ͹ģʽ
  *                        USART_IrDAMode_Normal  : ģʽ
  * @  û
  */
void USART_IrDAConfig(USART_TypeDef* USARTx, uint16_t USART_IrDAMode)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_IRDA_MODE(USART_IrDAMode));
    
  USARTx->CR3 &= CR3_IRLP_Mask;
  USARTx->CR3 |= USART_IrDAMode;
}

/**
  * @  ʹܻʧ USART IrDA ģʽ.
  * @  USARTx: ѡ USART  UART Χ豸.
  *                ֵ֮һ : USART1, USART2, USART3, UART4  UART5.
  * @  NewState: IrDA ģʽ״̬.
  *                  : ENABLE  DISABLE.
  * @  û
  */
void USART_IrDACmd(USART_TypeDef* USARTx, FunctionalState NewState)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_FUNCTIONAL_STATE(NewState));
    
  if (NewState != DISABLE)
  {
    /* ͨλCR3ĴIRENλʹIrDAģʽ */
    USARTx->CR3 |= CR3_IREN_Set;
  }
  else
  {
    /* ͨCR3ĴIRENλʧIrDAģʽ */
    USARTx->CR3 &= CR3_IREN_Reset;
  }
}

/**
  * @  ָ USART ־λ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_FLAG: ָҪı.
  *          ֵ֮һ :
  *          USART_FLAG_CTS:  CTS ı־ (Ӧ UART4  UART5)
  *          USART_FLAG_LBD:  LIN ־
  *          USART_FLAG_TXE:  ݼĴΪձ־
  *          USART_FLAG_TC:   ɱ־
  *          USART_FLAG_RXNE: ݼĴΪձ־
  *          USART_FLAG_IDLE: ߱־
  *          USART_FLAG_ORE:  ־
  *          USART_FLAG_NE:   ־
  *          USART_FLAG_FE:   ֡־
  *          USART_FLAG_PE:   ż־
  * @retval  USART_FLAG ״̬(SET  RESET).
  */
FlagStatus USART_GetFlagStatus(USART_TypeDef* USARTx, uint16_t USART_FLAG)
{
  FlagStatus bitstatus = RESET;
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_FLAG(USART_FLAG));
  /* CTS ־Ӧ UART4  UART5 */
  if (USART_FLAG == USART_FLAG_CTS)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  }  
  
  if ((USARTx->SR & USART_FLAG) != (uint16_t)RESET)
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  return bitstatus;
}

/**
  * @   USARTx Ĵ־λ.
  * @  USARTx: ѡ USART  UART Χ豸.
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_FLAG: ָҪı.
  *          ֵ:
  *          USART_FLAG_CTS:  CTS ı־ (Ӧ UART4  UART5).
  *          USART_FLAG_LBD:  LIN ־.
  *          USART_FLAG_TC:   ɱ־.
  *          USART_FLAG_RXNE: ݼĴΪձ־.
  *   
  * @ע
*          - PE (żУ), FE (), NE (),
*            ORE (ٴ)  IDLE (ҵ) ־־˳:
*            һUSART_SRĴUSART_GetFlagStatus()
*            һUSART_DRĴ(USART_ReceiveData()).
*          - RXNE־ҲԱһUSART_DRĴ(USART_ReceiveData()).
*          - TC־־˳: һUSART_SRĴUSART_GetFlagStatus()
*            һUSART_DRĴ(USART_ReceiveData()).                                                      
*          - TXE־ֻܿдUSART_DRĴ(USART_SendData()).     
  * @  û
  */
void USART_ClearFlag(USART_TypeDef* USARTx, uint16_t USART_FLAG)
{
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_CLEAR_FLAG(USART_FLAG));
  /* CTS ־Ӧ UART4  UART5 */
  if ((USART_FLAG & USART_FLAG_CTS) == USART_FLAG_CTS)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  } 
   
  USARTx->SR = (uint16_t)~USART_FLAG;
}

/**
  * @  ָ USART жϷ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_IT: ָҪUSARTжԴ.
  *          ֵ֮һ :
  *          USART_IT_CTS:  CTS ıж (Ӧ UART4  UART5)
  *          USART_IT_LBD:  LIN ж
  *          USART_IT_TXE:  ݼĴΪж
  *          USART_IT_TC:   ж
  *          USART_IT_RXNE: ݼĴΪж
  *          USART_IT_IDLE: ж
  *          USART_IT_ORE:  ж
  *          USART_IT_NE:   ж
  *          USART_IT_FE:   ֡ж
  *          USART_IT_PE:   żж
  * @  USART_IT ״̬ (SET  RESET).
  */
ITStatus USART_GetITStatus(USART_TypeDef* USARTx, uint16_t USART_IT)
{
  uint32_t bitpos = 0x00, itmask = 0x00, usartreg = 0x00;
  ITStatus bitstatus = RESET;
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_GET_IT(USART_IT));
  /* CTS жϲӦ UART4  UART5 */ 
  if (USART_IT == USART_IT_CTS)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  }   
  
  /* õ USART Ĵ */
  usartreg = (((uint8_t)USART_IT) >> 0x05);
  /*õжλ */
  itmask = USART_IT & IT_Mask;
  itmask = (uint32_t)0x01 << itmask;
  
  if (usartreg == 0x01) /* The IT  is in CR1 register */
  {
    itmask &= USARTx->CR1;
  }
  else if (usartreg == 0x02) /* The IT  is in CR2 register */
  {
    itmask &= USARTx->CR2;
  }
  else /* The IT  is in CR3 register */
  {
    itmask &= USARTx->CR3;
  }
  
  bitpos = USART_IT >> 0x08;
  bitpos = (uint32_t)0x01 << bitpos;
  bitpos &= USARTx->SR;
  if ((itmask != (uint16_t)RESET)&&(bitpos != (uint16_t)RESET))
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  
  return bitstatus;  
}

/**
  * @   USARTx жϴλ.
  * @  USARTx: ѡ USART  UART Χ豸. 
  *                ֵ֮һ : USART1, USART2, USART3, UART4 or UART5.
  * @  USART_IT: ָҪжϹλ.
  *          ֵ֮һ:
  *          USART_IT_CTS:  CTS ıж (Ӧ UART4  UART5)
  *          USART_IT_LBD:  LIN ж
  *          USART_IT_TC:   ж
  *          USART_IT_RXNE: ݼĴΪж
  *   
  * @ע
*          - PE (żУ), FE (), NE (),
*            ORE (ٴ)  IDLE (ҵ)λ 
*            ˳: һUSART_SRĴUSART_GetFlagStatus()
*            һUSART_DRĴ(USART_ReceiveData()).
*          - RXNEλҲԱһUSART_DRĴ(USART_ReceiveData()).
*          - TCλҲԱ˳: һUSART_SRĴUSART_GetFlagStatus()
*            һUSART_DRĴ(USART_ReceiveData()).                                                      
*          - TXEλÿԱһдUSART_DRĴ(USART_SendData()).  
  * @  û
  */
void USART_ClearITPendingBit(USART_TypeDef* USARTx, uint16_t USART_IT)
{
  uint16_t bitpos = 0x00, itmask = 0x00;
  /*  */
  assert_param(IS_USART_ALL_PERIPH(USARTx));
  assert_param(IS_USART_CLEAR_IT(USART_IT));
  /* CTS жϲӦ UART4  UART5 */
  if (USART_IT == USART_IT_CTS)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  }   
  
  bitpos = USART_IT >> 0x08;
  itmask = ((uint16_t)0x01 << (uint16_t)bitpos);
  USARTx->SR = (uint16_t)~itmask;
}
/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
